# BangBang

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliafolds2.github.io/BangBang.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliafolds2.github.io/BangBang.jl/dev)
[![Codecov](https://codecov.io/gh/JuliaFolds2/BangBang.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaFolds2/BangBang.jl)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)
![GitHub commits since latest release (branch)](https://img.shields.io/github/commits-since/JuliaFolds2/BangBang.jl/latest/master?style=social&logo=github)

BangBang.jl implements functions whose name ends with `!!`.  Those
functions provide a uniform interface for mutable and immutable data
structures.  Furthermore, those functions implement the "widening"
fallback for the case when the usual mutating function does not work (e.g.,
`push!!(Int[], 1.5)` creates a new array `Float64[1.5]`).

See the supported functions in the
[documentation](https://juliafolds2.github.io/BangBang.jl/dev)

module TestMul

include("preamble.jl")
using StaticArrays: SMatrix

@testset begin
    @test mul!!(0, 1, 2) === 2
    @test mul!!(missing, 1, 2) === 2
    @test mul!!(nothing, 1, 2) === 2

    C = zeros(2, 2)
    A = reshape(1:4, 2, 2)
    B = ones(2, 2)
    @test mul!!(C, A, B) === C
    @test C == A * B
    @test_inferred mul!!(C, A, B)

    C = zeros(Int, size(A * B))
    @test mul!!(C, A, B)::Matrix{Float64} == A * B
    @test_inferred mul!!(C, A, B)
end

if VERSION >= v"1.3"
    @testset "mul!(C, A, B, α, β)" begin
        @testset "$label" for (label, isinplace, C, A, B) in [
            (
             label = "C :: Matrix{Float64} (eltype compatible)",
             isinplace = true,
             C = zeros(2, 2),
             A = reshape(1:4, 2, 2),
             B = ones(2, 2),
            ),
            (
             label = "C :: Matrix{Int} (eltype compatible)",
             isinplace = true,
             C = zeros(Int, 2, 2),
             A = reshape(1:4, 2, 2),
             B = ones(Int, 2, 2),
            ),
            (
             label = "C :: Matrix{Int} (eltype incompatible)",
             isinplace = false,
             C = zeros(Int, 2, 2),
             A = reshape(1:4, 2, 2),
             B = ones(2, 2),
            ),
            (
             label = "C :: SMatrix",
             isinplace = false,
             C = SMatrix{2,2}(0, 0, 0, 0),
             A = SMatrix{2,2}(1, 2, 3, 4),
             B = SMatrix{2,2}(5, 6, 7, 8),
            ),
        ]
            desired = A * B * 3 + C * 4
            actual = mul!!(C, A, B, 3, 4)
            @test actual == desired
            if isinplace
                @test C === actual
            end
            @test_inferred mul!!(C, A, B, 3, 4)
        end
    end
end

end  # module

module TestPush

include("preamble.jl")
using BangBang.NoBang: push

@testset begin
    @test push!!([0.0], 1.0) == [0.0, 1.0]
    @test push!!([0], 1.0, 2im, UInt(3)) == [0.0, 1.0, 2im, 3]
    @test push!!([0], 1.0) == [0.0, 1.0]
    @test push!!((0,), 1) === (0, 1)
    @test push((0,), 1) === (0, 1)
    @test push!!((0,), 1.0, 2im, UInt(3)) === (0, 1.0, 2im, UInt(3))
    @test push((0,), 1.0, 2im, UInt(3)) === (0, 1.0, 2im, UInt(3))
    @test push!!((a=0,), :b => 1) === (a=0, b=1)
    @test push!!((a=0,), Val(:b) => 1) === (a=0, b=1)
    @test push!!(SVector(0), 1) === SVector(0, 1)
    @test push!!(SVector(0), 0.5) === SVector(0.0, 0.5)
    @test push!!(ImmutableDict(:a=>1), :b=>2) ==
        ImmutableDict(ImmutableDict(:a=>1), :b=>2)
    @test push!!(Dict(), :a=>1)::Dict{Any,Any} == Dict(:a=>1)
    @test push!!(Dict{Union{},Union{}}(), :a=>1)::Dict{Symbol,Int} == Dict(:a=>1)
    @test push!!(Set(), 1)::Set{Any} == Set(1)
    @test push!!(Set{Union{}}(), 1)::Set{Int} == Set(1)
end

@testset "error" begin
    err = @test_error push!!((a=1,), :b)
    @test occursin("`push(::NamedTuple, x::Symbol)` is not supported",
                   sprint(showerror, err))
end

end  # module

module TestMaterialize

include("preamble.jl")
using BangBang: air

@testset begin
    @test materialize!!(nothing, air.([0, 1] .+ 2))::Vector{Int} == [2, 3]
    @test materialize!!([NaN, NaN], air.([0, 1] .+ 2))::Vector{Real} == [2, 3]
    @test materialize!!(nothing, air.((0, 1) .+ 2))::Tuple === (2, 3)
    @test materialize!!(nothing, air.(SVector(0, 1) .+ 2))::SVector === SVector(2, 3)
end

@testset "widen" begin
    a0 = Real[1:3;]
    a = copy(a0)
    b = [0im] .+ (1:3)
    c = materialize!!(a, air.(a .+ b))
    @test c == a .+ b
    @test a == a0  # not modified
end

@testset "type-unstable materialize!!" begin
    unstabletrue = Ref{Any}(true)
    unstableone(unused) = unstabletrue[] ? unstabletrue[] : unused
    @test materialize!!(nothing, air.([1] .+ unstableone.([0]) ./ [1])) == [2]
end

end  # module

InitialValues.@def push!! [x]

# # Custom definition for `monoid!!(_, Init(monoid!!))`
#
# Using the default approach `InitialValues.@def_monoid monoid!!` was
# problematic because defining `monoid!!(::CustomType, x)` introduced
# method ambiguities.  It could be solved semi-automatically by
# `@disambiguate append!! CustomType` but it is very ugly and very
# problematic for the extensibility of the method.
#
# Furthermore, the definition
#
#     append!!(::InitAppend!!, src) = src
#
# that is generated by `@def_monoid` is not appropriate if `src`
# should be consumed by the time `append!!` is called (e.g.,
# https://discourse.julialang.org/t/38845/3).  This is mostly the case
# since the returned value of `monoid!!(init, src)` would be used as
# the first argument (i.e., it would be mutated) in the "next
# iteration" in reduction code idioms.  That is to say, `monoid!!`
# should not assume the ownership of the second argument.
#
# The method ambiguity problem is solved by introducing a "dispatch
# pipeline"; i.e., a `CustomType` implementer can overload
# `__monoid!!__` instead of `monoid!!`.
#
# The memory ownership problem is solved by defining InitialValues.jl
# interface manually.  For example, `append!!(::InitAppend!!, src)`
# now calls `copymutable(src)`.
#
# ## Alternative approach
#
# For `append!!`, an alternative approach considered is to create a
# custom `EmptyCollection` type that behaves like "an" identity
# element of `append!!`.  This may be possible by allowing
# `InitialValues.Init(::typeof(monoid!!))` overload.  This approach
# has some nice properties:
#
# * No need to define `append!!(::Any, ::InitType)` as it would work
#   via the default implementation of `append!!` based on iterator.
#   (The flip-side is that a bug could be hidden if the init object is
#   fed to other functions like `collect`. But this is not a serious
#   problem.)
#
# * By using the trait mechanism and defining `NoBang.append`,
#   `append!!` would behave as expected without any "surface"
#   dispatches.
#
# A *major downside* of this approach is that the fold code does not
# have a canonical way to check if `monoid!!` is ever called.  If
# overloading `InitialValues.Init` were supported, the fold
# implementers cannot simply call `acc isa InitialValue` to check if
# `acc = monoid!!(acc, x)` was called at least once.

const InitAppend!! = InitialValues.GenericInitialValue{typeof(append!!)}
append!!(::InitAppend!!, src) = copyappendable(src)
append!!(dest, ::InitAppend!!) = dest
append!!(dest::InitAppend!!, ::InitAppend!!) = dest
InitialValues.hasinitialvalue(::Type{typeof(append!!)}) = true

copyappendable(src) = Base.copymutable(src)

const InitMergeWith!!{F} = InitialValues.GenericInitialValue{MergeWith!!{F}}
(f::MergeWith!!{F})(dest::InitMergeWith!!{F}, src) where {F} = copymergeable(src)
(f::MergeWith!!{F})(dest, ::InitMergeWith!!{F}) where {F} = dest
(f::MergeWith!!{F})(dest::InitMergeWith!!{F}, src::InitMergeWith!!{F}) where {F} = dest
InitialValues.hasinitialvalue(::Type{MergeWith!!{F}}) where {F} = true

const InitMerge!! = InitialValues.GenericInitialValue{typeof(merge!!)}
merge!!(dest::InitMerge!!, src) = copymergeable(src)
merge!!(dest, ::InitMerge!!) = dest
merge!!(dest::InitMerge!!, src::InitMerge!!) = dest
merge!!(::Base.Callable, dest::InitMerge!!) = dest  # disambiguation
InitialValues.hasinitialvalue(::Type{typeof(merge!!)}) = true

copymergeable(src) = Dict(src)
copymergeable(src::NamedTuple) = src

const InitUnion!! = InitialValues.GenericInitialValue{typeof(union!!)}
union!!(dest::InitUnion!!, src) = copyunionable(src)
union!!(dest, ::InitUnion!!) = dest
union!!(dest::InitUnion!!, src::InitUnion!!) = dest
InitialValues.hasinitialvalue(::Type{typeof(union!!)}) = true

copyunionable(src::AbstractVector) = Base.copymutable(src)
copyunionable(src) = Set(src)

const InitIntersect!! = InitialValues.GenericInitialValue{typeof(intersect!!)}
intersect!!(dest::InitIntersect!!, src) = copyunionable(src)
intersect!!(dest, ::InitIntersect!!) = dest
intersect!!(dest::InitIntersect!!, src::InitIntersect!!) = dest
InitialValues.hasinitialvalue(::Type{typeof(intersect!!)}) = true

const InitSymdiff!! = InitialValues.GenericInitialValue{typeof(symdiff!!)}
symdiff!!(dest::InitSymdiff!!, src) = copyunionable(src)
symdiff!!(dest, ::InitSymdiff!!) = dest
symdiff!!(dest::InitSymdiff!!, src::InitSymdiff!!) = dest
InitialValues.hasinitialvalue(::Type{typeof(symdiff!!)}) = true

module TestLmul

include("preamble.jl")
using LinearAlgebra

@testset begin
    @test lmul!!(1, 2) === 2

    A = LowerTriangular(reshape(1:4, 2, 2))
    B = ones(2, 2)
    AB = A * B
    @test lmul!!(A, B) === B
    @test B == AB
    @test_inferred lmul!!(A, B)

    A = LowerTriangular(collect(Float64, reshape(1:4, 2, 2)))
    B = ones(Int, 2, 2)
    AB = A * B
    @test lmul!!(A, B) :: Matrix{Float64} == AB
    @test_inferred lmul!!(A, B)
end

end  # module

module BangBangTypedTablesExt
@static if isdefined(Base, :get_extension)
    using BangBang
    using BangBang.NoBang 
    using TypedTables
else
    using ..BangBang
    using ..BangBang.NoBang 
    using ..TypedTables
end
    Base.append!(dest::TypedTables.Table, src::NoBang.SingletonVector{<:NamedTuple}) =
    push!(dest, first(src))
end

module TestSymdiff

include("preamble.jl")
# using MicroCollections: SingletonSet

@testset begin
    @test_returns_first symdiff!!([0]) == [0]
    @test_returns_first symdiff!!(Set([0])) == Set([0])
    @test_returns_first symdiff!!([0], [0]) == []
    @test_returns_first symdiff!!([0], (0,)) == []
    @test_returns_first symdiff!!([0, 1, 2], (0, 1), [1, 3]) == [1, 2, 3]
    @test_returns_first symdiff!!(Set([0]), [0]) == Set()
    @test_returns_first symdiff!!(Set([0]), (1,)) == Set([0, 1])
    @test_returns_first symdiff!!(Set([0, 1, 2]), Set([0, 1]), [1]) == Set([1, 2])
    @test symdiff!!(Empty(Set)) === Empty(Set)
    @test symdiff!!(Empty(Vector), Empty(Vector)) === Empty(Vector)
    @test symdiff!!(Empty(Set{Int}), Empty(Vector)) === Empty(Set{Int})
    #=
    @test symdiff!!(SingletonSet((0,)), [0]) ==ₜ Set{Int}()
    @test symdiff!!(SingletonSet((0,)), [1]) ==ₜ Set([0, 1])
    =#
end

end  # module

module BangBangDataFramesExt
@static if isdefined(Base, :get_extension)
    using BangBang
    using Base: setindex!
    using DataFrames
    using DataFrames.Tables: Tables
else
    using ..BangBang
    using ..Base: setindex!
    using ..DataFrames
    using ..DataFrames.Tables: Tables
end
    BangBang.push!!(df::DataFrames.DataFrame, row) = df_append_rows!!(df, (row,))
    BangBang.append!!(df::DataFrames.DataFrame, source) = df_append!!(df, source)
    BangBang.copyappendable(df::DataFrames.AbstractDataFrame) = copy(df)

    function BangBang.setindex!!(
        df::DataFrames.DataFrame,
        v,
        row::Union{Integer,Colon,AbstractVector{<:Integer}},
        col::Union{Integer,Symbol,AbstractString},
    )
        col_idx = col isa Integer ? Int(col) : DataFrames.columnindex(df, col)
        columns = getfield(df, :columns)
        old_col = columns[col_idx]
        new_col = BangBang.setindex!!(old_col, v, row)
        if new_col !== old_col
            columns[col_idx] = new_col
        end
        return df
    end

    _getvalue(x, pos, name) = getproperty(x, name)
    _getvalue(x::AbstractVector, pos, name) = x[pos]
    _getvalue(x::Tuple, pos, name) = x[pos]
    _getvalue(x::NamedTuple, pos, name) = x[name]
    _getvalue(x::AbstractDict, pos, name) = x[name]

    _hascolumn(x, n) = hasproperty(x, n)
    _hascolumn(::NamedTuple{names}, n) where {names} = n in names  # optimization
    _hascolumn(x::AbstractDict, n) = haskey(x, n)

    ncolumns(x) = length(propertynames(x))  # e.g., Tables.IteratorRow
    ncolumns(x::Union{NamedTuple, AbstractDict}) = length(x)

    function checkcolumnnames(x, columnnames)
        for n in columnnames
            _hascolumn(x, n) || error("No column `", n, "` in given row.")
        end
        nc = ncolumns(x)
        length(columnnames) < nc && error("More columns exist in given row.")
        @assert length(columnnames) == nc
    end

    function checkcolumnnames(x::Union{Tuple,AbstractVector}, columnnames)
        length(columnnames) == length(x) || error("Number of columns does not match.")
    end

    function df_append_columns!!(df, table)
        columns = getfield(df, :columns)
        colnames = DataFrames._names(df)  # avoid copy
        checkcolumnnames(columns, colnames)
        for (pos, (name, col)) in enumerate(zip(colnames, columns))
            columns[pos] = BangBang.append!!(col, _getvalue(table, pos, name))
        end
        return df
    end

    macro manually_specialize(expr, head, tail...)
        Expr(:if, head, expr, manually_specialize_impl(expr, tail)) |> esc
    end

    manually_specialize_impl(expr, predicates) =
        if isempty(predicates)
            expr
        else
            Expr(
                :elseif,
                predicates[1],
                expr,
                manually_specialize_impl(expr, predicates[2:end]),
            )
        end

    function df_append_rows!!(df, table)
        columns = getfield(df, :columns)
        colnames = DataFrames._names(df)  # avoid copy
        # colnames = propertynames(df)
        for x in table
            checkcolumnnames(x, colnames)
            for (pos, (name, col)) in enumerate(zip(colnames, columns))
                v = _getvalue(x, pos, name)
                @manually_specialize(
                    columns[pos] = BangBang.push!!(col, v),
                    # "Inline" some method lookups for typical column types:
                    col isa Vector{Int},
                    col isa Vector{Union{Int,Missing}},
                    col isa Vector{Float64},
                    col isa Vector{Union{Float64,Missing}},
                    col isa Vector{Symbol},
                    col isa Vector{Union{Symbol,Missing}},
                    col isa Vector{String},
                    col isa Vector{Union{String,Missing}},
                )
            end
        end
        return df
    end

    df_append!!(df, table) =
        if Tables.columnaccess(table)
            df_append_columns!!(df, Tables.columns(table))
        elseif Tables.rowaccess(table)
            df_append_rows!!(df, Tables.rows(table))
        else
            df_append_rows!!(df, table)
        end
end

# Helper types for implementing `push`


struct SingletonVector{T} <: AbstractVector{T}
    value::T
end

Base.size(::SingletonVector) = (1,)
Base.first(v::SingletonVector) = v.value
Base.last(v::SingletonVector) = v.value

function Base.getindex(v::SingletonVector, i::Integer)
    @boundscheck i == 1 || throw(BoundsError(v, i))
    return v.value
end

struct _NoValue end

@inline Base.foldl(op, v::SingletonVector; init = _NoValue()) =
    init isa _NoValue ? v.value : op(init, v.value)


struct SingletonDict{K,V} <: AbstractDict{K,V}
    key::K
    value::V
end

SingletonDict((key, value)::Pair) = SingletonDict(key, value)

Base.iterate(d::SingletonDict) = (d.key => d.value, nothing)
Base.iterate(d::SingletonDict, ::Nothing) = nothing

Base.first(d::SingletonDict) = d.key => d.value
Base.last(d::SingletonDict) = d.key => d.value

function Base.getindex(d::SingletonDict{K}, key::K) where {K}
    @boundscheck isequal(d.key, key) || throw(BoundsError(d, key))
    return d.value
end

Base.get(d::SingletonDict, k, v) = isequal(d.key, k) ? d.value : v

Base.length(::SingletonDict) = 1

module TestPushfirst

include("preamble.jl")

@testset begin
    @test pushfirst!!([0.0], 1.0) == [1.0, 0.0]
    @test pushfirst!!([0], 1.0) == [1.0, 0.0]
    @test pushfirst!!((0,), 1) === (1, 0)
    @test pushfirst!!(SVector(0), 1) == SVector(1, 0)
    @test pushfirst!!(SVector(0), 1) === SVector(1, 0)
end

end  # module

"""
    Empty(T)

Create a proxy of an empty container of type `T`.

This is a simple API for solving problems such as:

* There is no consistent way to create an empty container given its type.
* There is no consistent way to know that nothing was appended into the
  container in type-domain.

Internally, this function simply works by creating a singleton container
(a container with one element) using [`singletonof`](@ref) when the first
element is [`push!!`](@ref)'ed.

# Examples
```jldoctest
julia> using BangBang

julia> push!!(Empty(Vector), 1)
1-element Vector{Int64}:
 1

julia> append!!(Empty(Dict), (:a=>1, :b=>2))
Dict{Symbol, Int64} with 2 entries:
  :a => 1
  :b => 2

julia> using DataFrames: DataFrame

julia> @assert push!!(Empty(DataFrame), (a=1, b=2)) == DataFrame(a=[1], b=[2])

julia> using StructArrays: StructVector

julia> @assert push!!(Empty(StructVector), (a=1, b=2)) == StructVector(a=[1], b=[2])

julia> using TypedTables: Table

julia> @assert push!!(Empty(Table), (a=1, b=2)) == Table(a=[1], b=[2])

julia> using StaticArrays: SVector

julia> @assert push!!(Empty(SVector), 1) === SVector(1)
```

`Empty(T)` object is an iterable with length 0 and element type `Union{}`:

```jldoctest; setup=:(using BangBang)
julia> collect(Empty(Vector))
Union{}[]

julia> length(Empty(Vector))
0

julia> eltype(typeof(Empty(Vector)))
Union{}

julia> Base.IteratorSize(Empty)
Base.HasLength()

julia> Base.IteratorEltype(Empty)
Base.HasEltype()
```
"""
struct Empty{T} end
Empty(T::Type) = Empty{T}()

push(::Empty{T}, x) where T = singletonof(T, x)
append(::Empty{T}, x) where T = T(x)
# In `append`, it is assumed that `T(x::Vector)` works (as done in the
# implementation of `singletonof`).

append(e::Empty, ::Empty) = e

_empty(x::Empty) = x
resize(::Empty{T}, n::Integer) where {T <: AbstractVector} = similar(T, (n,))

_union(::Empty{T}, x, ys...) where {T} = union!!(unique!!(T(x)), ys...)
_union(e::Empty, ::Empty...) = e

_intersect(x::Empty, ys...) = x

_setdiff(x::Empty, ys...) = x

_symdiff(::Empty{T}, x, ys...) where {T} = symdiff!!(unique!!(T(x)), ys...)
_symdiff(e::Empty, ::Empty...) = e

_setindex(::Empty{T}, v, k) where {T <: AbstractDict} = T(SingletonDict(k, v))
Base.get(::Empty, _, default) = default

Base.IteratorSize(::Type{<:Empty}) = Base.HasLength()
Base.IteratorEltype(::Type{<:Empty}) = Base.HasEltype()
Base.eltype(::Type{<:Empty}) = Union{}
Base.eltype(::Type{<:Empty{<:AbstractVector{T}}}) where {T} = T
Base.length(::Empty) = 0
Base.iterate(::Empty) = nothing
Base.haskey(::Empty, ::Any) = false

Base.firstindex(::Empty{<:Vector}) = 1
Base.lastindex(::Empty{<:Vector}) = 0
Base.similar(e::Empty) = similar(e, eltype(e), (0,))
Base.similar(e::Empty, dims::Int...) = similar(e, eltype(e), dims)
Base.similar(e::Empty, dims::Tuple{Vararg{Int}}) = similar(e, eltype(e), dims)
Base.similar(e::Empty, T::Type) = similar(e, T, (0,))
Base.similar(e::Empty, T::Type, dims::Int...) = similar(e, T, dims)
Base.similar(::Empty{<:Vector}, T::Type, dims::Tuple{Vararg{Int}}) =
    similar(Vector{T}, dims)
Base.similar(::Empty{Vector{T}}, dims::Tuple{Vararg{Int}}) where {T} =
    similar(Vector{T}, dims)

"""
    @! expr

Convert all supported mutating calls to double bang equivalent.

# Examples
```jldoctest
julia> using BangBang

julia> @! push!(empty!((0, 1)), 2, 3)
(2, 3)

julia> y = [1, 2];

julia> @! y .= 2 .* y
       y
2-element Vector{Int64}:
 2
 4

julia> y = (1, 2);

julia> @! y .= 2 .* y
       y
(2, 4)
```
"""
macro !(expr)
    foldexpr(macroexpand(__module__, expr)) do x
        if Meta.isexpr(x, :call)
            isdotoperator(x.args[1]) && return x
            return Expr(:call, Expr(:call, _maybb, x.args[1]), x.args[2:end]...)
        elseif isdotoperator(x.head) && isequalsoperator(x.head) && x.args[1] isa Symbol
            @assert length(x.args) == 2
            lhs, rhs = x.args
            op = unequalsoperator(undotoperator(x.head))
            if isnothing(op)
                return :($lhs = $materialize!!(
                    $Base.@isdefined($lhs) ? $lhs : $(Undefined()),
                    $rhs,
                ))
            end
            return :($lhs = $(Extras.broadcast_inplace!!)($op, $lhs, $rhs))
        end
        return x
    end |> esc
end

foldexpr(f, x) = x
foldexpr(f, ex::Expr) = f(Expr(ex.head, foldexpr.(f, ex.args)...))

isdotoperator(x::Symbol) = undotoperator(x) !== nothing

isequalsoperator(x::Symbol) = unequalsoperator(x) !== nothing

function undotoperator(x::Symbol)
    startswith(string(x), ".") || return nothing
    op = Symbol(string(x)[2:end])
    Base.isoperator(op) || return nothing
    return op
end

function unequalsoperator(x::Symbol)
    endswith(string(x), "=") || return nothing
    op = Symbol(string(x)[1:end-1])
    Base.isoperator(op) || return nothing
    return op
end

# Should not be required anymore. Keep for backwards compatibility?
function air end
struct Aired{T}
    value::T
end
@inline Broadcast.broadcasted(::typeof(air), x) = Aired(x)
@inline Broadcast.materialize(x::Aired) = x.value

module TestTypedTables

include("preamble.jl")
using BangBang
using BangBang: SingletonVector
using ConstructionBase: constructorof
using Test
using TypedTables

@testset "push!!" begin
    tints = Table(a = [1], b = [2])
    @test push!!(tints, (a = 3.0, b = 4.0))::Table == Table(a = [1.0, 3.0], b = [2.0, 4.0])
    @test tints == Table(a = [1], b = [2])

    tints = Table(a = [1], b = [2])
    @test push!!(tints, (a = 3, b = 4)) === tints
    @test tints == Table(a = [1, 3], b = [2, 4])
end

@testset "append!!(::Table, ::$(constructorof(typeof(src)))) [widen]" for src in Any[
    [(a = 3.0, b = 4.0)],
    SingletonVector((a = 3.0, b = 4.0)),
]
    tints = Table(a = [1], b = [2])
    @test append!!(tints, src)::Table == Table(
        a = [1.0, 3.0],
        b = [2.0, 4.0],
    )
    @test tints == Table(a = [1], b = [2])
end

@testset "append!!(::Table, ::$(constructorof(typeof(src)))) [mutation]" for src in Any[
    # Broken:
    # [(a = 3, b = 4)],
    SingletonVector((a = 3, b = 4)),
]
    tints = Table(a = [1], b = [2])
    @test append!!(tints, src) === tints == Table(
        a = [1, 3],
        b = [2, 4],
    )
end

@testset "append!!" begin
    if versionof(TypedTables) >= v"1.2.4" && VERSION >= v"1.4" # could be older
        tints = Table(a = [1], b = [2])
        if VERSION > v"1.10-"
            @info "spipping this test due to https://github.com/JuliaLang/julia/issues/49748"
            @test_skip append!!(tints, [(a = 3, b = 4)]) === tints
            @test_skip tints == Table(a = [1, 3], b = [2, 4])
        else
            @test append!!(tints, [(a = 3, b = 4)]) === tints
            @test tints == Table(a = [1, 3], b = [2, 4])
        end
    end
end

@testset "type inference" begin
    @test (@inferred singletonof(Table, (a=1,))) == Table((a=[1]))
end

end  # module

module NoBang

export Empty, singletonof

using Base.Iterators: Pairs
using Base: ImmutableDict
using ConstructionBase: constructorof, setproperties

using ..BangBang: push!!, unique!!, union!!, symdiff!!, implements

include("singletoncontainers.jl")
include("base.jl")
include("linearalgebra.jl")
include("singletonof.jl")
include("emptycontainers.jl")

end  # module

module BenchMergewith

using BangBang: mergewith!!, right
using BenchmarkTools: @benchmarkable, BenchmarkGroup

const suite = BenchmarkGroup()

src1 = Dict{Int,Int}(rand(Int, 1000) .=> 1)

for (clabel, cfun) in [:right => right, :+ => +]
    s0 = suite[:combine=>clabel] = BenchmarkGroup()

    s1 = s0[:desttype=>:compatible] = BenchmarkGroup()
    s1[:destkeys=>:empty] =
        @benchmarkable(mergewith!!($cfun, dest, $src1); setup = (dest = Dict{Int,Int}()))
    s1[:destkeys=>:equal] =
        @benchmarkable(mergewith!!($cfun, dest, $src1); setup = (dest = copy($src1)))
    s1[:destkeys=>:half] = @benchmarkable(
        mergewith!!($cfun, dest, $src1);
        setup = (dest = Dict{Int,Int}(collect(keys($src1))[1:end÷2] .=> 1))
    )

    s2 = s0[:desttype=>:widen] = BenchmarkGroup()
    s2[:destkeys=>:empty] =
        @benchmarkable(mergewith!!($cfun, dest, $src1); setup = (dest = Dict{Bool,Int}()))
end

end  # module
BenchMergewith.suite

using InteractiveUtils: code_llvm
using Test

include("../benchmark/map.jl")

"""
    llvm_ir(f, args) :: String

Get LLVM IR of `f(args...)` as a string.
"""
llvm_ir(f, args) = sprint(code_llvm, f, Base.typesof(args...))

nmatches(r, s) = count(_ -> true, eachmatch(r, s))

twice(x) = 2x

@testset "setindex!! (@inbounds)" begin
    @test mapbb(twice, [1:3;], Val(false)) == [2, 4, 6]

    ir_noinbounds = llvm_ir(mapbb, (twice, Float64[], Val(false)))
    @debug "LLVM IR" ir_noinbounds=Text(ir_noinbounds)
    if Base.JLOptions().check_bounds == 2  # --check-bounds=no
        @test nmatches(r"fmul <[0-9]+ x double>", ir_noinbounds) >= 4
    else
        @test nmatches(r"fmul <[0-9]+ x double>", ir_noinbounds) == 0
    end
    ir_inbounds = llvm_ir(mapbb, (twice, Float64[], Val(true)))
    @debug "LLVM IR" ir_inbounds=Text(ir_noinbounds)
    @test nmatches(r"fmul <[0-9]+ x double>", ir_inbounds) >= 4
end

"""
    add!!(A, B) -> A′

`A .+= B` if possible; otherwise return `A .+ B`.

# Examples
```jldoctest
julia> using BangBang: add!!

julia> add!!((1,), (2,))
(3,)

julia> add!!([1], [2])
1-element Vector{Int64}:
 3
```
"""
add!!
add!!(A, B) = materialize!!(A, instantiate(broadcasted(+, A, B)))

"""
    mul!!(C, A, B, [α, β]) -> C′
"""
mul!!
mul!!(C, A, B) = may(mul!, C, A, B)
mul!!(C, A, B, α, β) = may(mul!, C, A, B, α, β)

pure(::typeof(mul!)) = NoBang.mul
_asbb(::typeof(mul!)) = mul!!
possible(::typeof(mul!), C, A, B) =
    implements(push!, C) && _matmuleltype(A, B) <: eltype(C)
possible(::typeof(mul!), C, A, B, α, β) =
    implements(push!, C) && _matmuleltype(C, A, B, α, β) <: eltype(C)

# Estimate `eltype` of `C`.  This is how it's done in LinearAlgebra.jl
# but maybe it's better to use the approach of
# https://github.com/tpapp/AlgebraResultTypes.jl ?
_matprod(x, y) = x * y + x * y
_matprod(c, a, b, α, β) = a * b * α + a * b * α + c * β
_matmuleltype(A, B) = Base.promote_op(_matprod, eltype(A), eltype(B))
_matmuleltype(C, A, B, α, β) =
    Base.promote_op(_matprod, eltype(C), eltype(A), eltype(B), typeof(α), typeof(β))

"""
    lmul!!(A, B) -> B′
"""
lmul!!
lmul!!(A, B) = may(lmul!, A, B)

pure(::typeof(lmul!)) = *
_asbb(::typeof(lmul!)) = lmul!!
possible(::typeof(lmul!), A, B) =
    implements(push!, B) && _matmuleltype(A, B) <: eltype(B)

"""
    rmul!!(A, B) -> A′
"""
rmul!!
rmul!!(A, B) = may(rmul!, A, B)

pure(::typeof(rmul!)) = *
_asbb(::typeof(rmul!)) = rmul!!
possible(::typeof(rmul!), A, B) =
    implements(push!, A) && _matmuleltype(A, B) <: eltype(A)

module TestBroadcast

using BangBang
using BangBang.Extras
using Test

@testset "broadcast!!" begin
    @testset "mutate" begin
        xs = fill(1234, 3)
        @test broadcast!!(+, xs, zeros(Int, 3), 1) === xs == ones(Int, 3)
    end

    @testset "widen" begin
        xs = fill(123, 3)
        @test broadcast!!(+, xs, [1, 2, 3], 0.5) == [1.5, 2.5, 3.5]
        @test all(==(123), xs)
    end
end

@testset "broadcast_inplace!!" begin
    @testset "mutate" begin
        xs = zeros(Int, 3)
        @test broadcast_inplace!!(+, xs, 1) === xs == ones(Int, 3)
    end

    @testset "widen" begin
        xs = ones(Int, 3)
        @test broadcast_inplace!!(+, xs, [1, 2, 3], 0.5) == [2.5, 3.5, 4.5]
        @test all(==(1), xs)
    end
end

end  # module

module AccessorsImpl

export @set!!, prefermutation

using ..BangBang: setproperty!!, setindex!!
#using Setfield: ComposedLens, DynamicIndexLens, IndexLens, Lens, PropertyLens, Setfield, set
using Accessors: Accessors, IndexLens, PropertyLens, set, get, ComposedOptic
struct Lens!!{T}
    lens::T
end
(l::Lens!!)(o) = l.lens(o)

Accessors.get(obj, lens::Lens!!) = get(obj, lens.lens)

# Default to immutable:
Accessors.set(obj, lens::Lens!!, value) = set(obj, lens.lens, value)

Accessors.set(obj, lens::Lens!!{<:ComposedOptic}, value) =
    set(obj, Lens!!(lens.lens.outer) ∘ Lens!!(lens.lens.inner), value)

Accessors.set(obj, ::Lens!!{<:PropertyLens{fieldname}}, value) where {fieldname} =
    setproperty!!(obj, fieldname, value)

indicesfor(lens::IndexLens, _) = lens.indices
# indicesfor(lens::DynamicIndexLens, obj) = lens.f(obj)

# if isdefined(Setfield, :ConstIndexLens)
#     using Setfield: ConstIndexLens
#     const SupportedIndexLens = Union{ConstIndexLens,DynamicIndexLens,IndexLens}
#     indicesfor(::ConstIndexLens{I}, _) where {I} = I
# else
#     const SupportedIndexLens = Union{DynamicIndexLens,IndexLens}
# end

Accessors.set(obj, lens::Lens!!{<:IndexLens}, value) =
    setindex!!(obj, value, indicesfor(lens.lens, obj)...)

"""
    prefermutation(lens::Lens) :: Lens

See also [`@set!!`](@ref).
"""
prefermutation
prefermutation(lens) = Lens!!(lens)

"""
    @set!! assignment

Like `Accessors.@set`, but prefer mutation if possible.

# Examples
```jldoctest
julia> using BangBang

julia> mutable struct Mutable
           a
           b
       end

julia> x = orig = Mutable((x=Mutable(1, 2), y=3), 4);

julia> @set!! x.a.x.a = 10;

julia> @assert x.a.x.a == orig.a.x.a == 10
```
"""
:(@set!!)
macro set!!(ex)
    Accessors.setmacro(prefermutation, ex, overwrite = true)
end

end  # module

module TestAccessors

include("preamble.jl")
using Accessors: @optic, Accessors, set

struct LensWrapper
    lens::Any
end

Accessors.get(obj, lens::LensWrapper) = get(obj, lens.lens)
Accessors.set(obj, lens::LensWrapper, value) = set(obj, lens.lens, value)

mutable struct Mutable
    a
    b
end

@testset "nested mutable" begin
    x = orig = Mutable((x=Mutable(1, 2), y=3), 4);
    @set!! x.a.x.a = 10;
    @test x.a.x.a == orig.a.x.a == 10
end

@testset "arrays" begin
    v = [1, 2, Mutable(1, 2)]
    x = orig = Mutable((x=v, y=3), 4);
    @set!! x.a.x[3].a = 10;
    @test x.a.x[3].a == orig.a.x[3].a == 10
    @test x.a.x === v
end

@testset "index lenses" begin
    @static if isdefined(Accessors, :ConstIndexLens)
        @testset "ConstIndexLens" begin
            v = [1, 2, 3]
            i = j = 1
            @set!! v[$(i + j)] = 20
            @test v[2] == 20
        end
    end
    @testset "DynamicIndexLens" begin
        v = [1, 2, 3]
        @set!! v[end] = 30
        @test v[3] == 30
    end
end

@testset "default to immutable" begin
    x = Mutable((x=Mutable(1, 2), y=3), 4);
    l = prefermutation(LensWrapper(@optic _.a.x.a))
    y = set(x, l, 10)
    @test y !== x
    @test y.a.x.a == 10
end

end  # module

module TestModify

include("preamble.jl")
using BangBang.Extras: modify!!

function modify!(f, d, k)
    d′, v = modify!!(f, d, k)
    @test d′ === d
    return v
end

@testset "modify!(f, ::$constructor, key)" for constructor in [
    Dict,
    # SingletonDict,
]
    @testset "update" begin
        dict = constructor(Dict("a" => 1))

        @test modify!(dict, "a") do old
            Some(something(old, 0) + 1)
        end == Some(2)

        @test Dict(dict) == Dict("a" => 2)
    end

    @testset "insert" begin
        dict = constructor(Dict())

        @test modify!(dict, "a") do old
            Some(something(old, 0) + 1)
        end == Some(1)

        @test Dict(dict) == Dict("a" => 1)
    end

    @testset "delete" begin
        dict = constructor(Dict("a" => 1))
        @test modify!(_ -> nothing, dict, "a") === nothing
        @test Dict(dict) == Dict()
    end

    @testset "no-op" begin
        dict = constructor(Dict("a" => 1))
        @test modify!(_ -> nothing, dict, "b") === nothing
        @test Dict(dict) == Dict("a" => 1)

        dict = constructor(Dict("a" => 1))
        @test modify!(_ -> nothing, dict, :b) === nothing
        @test Dict(dict) == Dict("a" => 1)

        dict = constructor(Dict("a" => 1))
        @test modify!(identity, dict, "a") === Some(1)
        @test Dict(dict) == Dict("a" => 1)

        dict = constructor(Dict(:a => 1))
        @test modify!(identity, dict, :a) === Some(1)
        @test Dict(dict) == Dict(:a => 1)
    end

    @testset "mutation inside `f`" begin
        dict = constructor(Dict())

        @test modify!(dict, "a") do old
            dict["a"] = 0
            Some(something(old, 0) + 1)
        end == Some(1)

        @test Dict(dict) == Dict("a" => 1)
    end
end

@testset "modify!!(f, ::Dict, key)" begin
    @testset "update" begin
        dict = Dict("a" => 1)
        backup = deepcopy(dict)
        dict′, ret = modify!!(dict, "a") do old
            Some(something(old, 0) + 0.5)
        end
        @test ret === Some(1.5)
        @test dict′ == Dict("a" => 1.5)
        @test dict == backup
    end

    @testset "insert" begin
        dict = Dict{Union{},Union{}}()
        backup = deepcopy(dict)
        dict′, ret = modify!!(dict, "a") do old
            Some(something(old, 0) + 1)
        end
        @test ret == Some(1)
        @test dict′ == Dict("a" => 1)
        @test dict == backup
    end

    @testset "no-op" begin
        dict = Dict("a" => 1)
        backup = deepcopy(dict)
        dict′, ret = modify!!(_ -> nothing, dict, :b)
        @test ret === nothing
        @test dict′ === dict == backup
    end

    @testset "mutation inside `f` while widening value type" begin
        dict = Dict{String,Int}()
        dict′, ret = modify!!(dict, "a") do old
            dict["a"] = 0
            Some(something(old, 0) + 0.5)
        end
        @test ret === Some(0.5)
        @test dict′ == Dict("a" => 0.5)
        @test dict == Dict("a" => 0)
    end

    @testset "mutation inside `f` while widening key type" begin
        dict = Dict{String,Int}()
        dict′, ret = modify!!(dict, :b) do old
            dict["a"] = 0
            Some(something(old, 0) + 0.5)
        end
        @test ret === Some(0.5)
        @test dict′ == Dict("a" => 0, :b => 0.5)
        @test dict == Dict("a" => 0)
    end
end

@testset "modify!!(f, ::NamedTuple, key)" begin
    @testset "update" begin
        @test modify!!((a = 1,), :a) do old
            Some(something(old, 0) + 1)
        end === ((a = 2,), Some(2))
    end

    @testset "insert" begin
        @test modify!!(NamedTuple(), :a) do old
            Some(something(old, 0) + 1)
        end === ((a = 1,), Some(1))
    end

    @testset "delete" begin
        @test modify!!((a = 1,), :a) do old
            nothing
        end === (NamedTuple(), nothing)
    end

    @testset "no-op" begin
        @test modify!!((a = 1,), :b) do old
            nothing
        end === ((a = 1,), nothing)
    end
end

end  # module

"""
    singletonof(::Type{T}, x) :: T
    singletonof(::T, x) :: T

Create a singleton container of type `T`.

# Examples
```jldoctest
julia> using BangBang

julia> @assert singletonof(Vector, 1) == [1]

julia> @assert singletonof(Dict, :a => 1) == Dict(:a => 1)

julia> @assert singletonof(Set, 1) == Set([1])

julia> using StructArrays: StructVector

julia> @assert singletonof(StructVector, (a=1, b=2)) == StructVector(a=[1], b=[2])

julia> using TypedTables: Table

julia> @assert singletonof(Table, (a=1, b=2)) == Table(a=[1], b=[2])

julia> using StaticArrays: SArray, SVector

julia> @assert singletonof(SArray, 1) === SVector(1)

julia> @assert singletonof(SVector, 1) === SVector(1)
```
"""
singletonof(::Type{T}, x) where T = T(SingletonVector(x))

function singletonof(::T, x) where T
    C = constructorof(T)
    return singletonof(C isa Type ? C : T, x)
end

module TestDelete

include("preamble.jl")

@testset begin
    @test delete!!((a = 1,), :a) === NamedTuple()
    @test delete!!((a = 1,), :b) === (a = 1,)
    @test delete!!(Dict(:a => 1), :a) == Dict()
    @test delete!!(Dict(:a => 1), :b) == Dict(:a => 1)
end

end  # module

using BangBang

struct UndefArray{N, T <: NTuple{N, Int}} <: AbstractArray{Union{}, N}
    size::T
end

Base.size(arr::UndefArray) = arr.size
Base.isassigned(::UndefArray, ::Integer...) = false

function BangBang.NoBang._setindex(x::UndefArray{N}, v, I...) where N
    ys = Array{typeof(v), N}(undef, x.size...)
    ys[I...] = v
    return ys
end


mapbb(f, xs::Array, inbounds::Val = Val(true)) =
    __map!!(f, UndefArray(size(xs)), xs, 1, inbounds)


@inline function __map!!(f, ys, xs, n, inbounds)
    @simd for i in n:length(ys)
        if inbounds === Val(true)
            @inbounds begin
                ys′ = setindex!!(ys, f(xs[i]), i)
            end
        else
            ys′ = setindex!!(ys, f(xs[i]), i)
        end
        if !(ys′ isa typeof(ys))
            return __map!!(f, ys′, xs, i + 1, inbounds)
        end
    end
    return ys
end

module BangBangChainRulesCoreExt
    # https://fluxml.ai/Zygote.jl/dev/adjoints/#Gradient-Reflection-1
@static if isdefined(Base, :get_extension)
    using BangBang: possible
    using ChainRulesCore
else
    using ..BangBang: possible
    using ..ChainRulesCore
end

    # Treat everything immutable during differentiation:
    ChainRulesCore.rrule(::typeof(possible), _...) = false, _ -> ChainRulesCore.NoTangent()
end

module TestCore

include("preamble.jl")

@testset begin
    @test implements(push!, [])
    @test implements(push!, Dict(:a=>1))
    @test !implements(push!, ())
    @test !implements(push!, (a=1,))
    @test !implements(push!, SVector(0))
end

end  # module

module BenchAppend

using BangBang: Empty, append!!, empty!!
using BangBang.NoBang: SingletonVector
using BenchmarkTools: @benchmarkable, BenchmarkGroup
using StaticArrays: SVector

function repeat_append!(dest, src, n_repeat = 100, n_values = 1000)
    for _ = 1:n_repeat
        x = empty!!(dest)
        for _ in 1:n_values
            append!!(x, src)
        end
    end
end

repeat_append(dest, src) =
    foldl(append!!, ntuple(_ -> src, 10); init = dest)

suite = BenchmarkGroup()
suite["append!!(::Vector, ::SingletonVector)"] =
    @benchmarkable(repeat_append!($(Float64[]), SingletonVector(1.0)))
suite["append!!(::SVector, ::SingletonVector)"] =
    @benchmarkable(repeat_append(SVector{0,Float64}(), SingletonVector(1.0)))
suite["append!!(Empty(SVector), ::SingletonVector)"] =
    @benchmarkable(repeat_append(Empty(SVector), SingletonVector(1.0)))

end  # module
BenchAppend.suite

using BangBang
using LinearAlgebra

function rnn!!(n, J, x)
    dest = x
    y = similar(x)
    for _ in 1:n
        @! y = mul!(y, J, x)
        @! y .= tanh.(y)
        x, y = y, x
    end
    @! dest .= x
    return dest
end

using Zygote
d = 10
J = randn(d, d)
x0 = randn(d)
y_target = randn(d)
g, = Zygote.gradient(J -> sum((rnn!!(20, J, x0) .- y_target) .^ 2), J)

using BenchmarkTools
SUITE = BenchmarkGroup()
bench_re = r"bench_(?<bname>.*)\.jl"
for file in readdir(@__DIR__)
    m = match(bench_re, file) 
    if !isnothing(m)
	SUITE[m[:bname]] = include(file)
    end
end
let suite = SUITE, params_file = "SUITE_tuning.json"
    if isfile(params_file)
        loadparams!(suite, BenchmarkTools.load(params_file)[1], :evals, :samples);    
    else
        tune!(suite)
        BenchmarkTools.save(params_file, params(suite));
    end
end

# results = run(SUITE, verbose = true, seconds = 5)

module TestSingletonContainers

using BangBang.NoBang: SingletonDict, SingletonVector
using Tables: Tables
using Test

function test_shows(x)
    # smoke tests
    @test sprint(show, x) isa String
    @test sprint(show, "text/plain", x) isa String
    @test string(x) isa String
end

@testset "SingletonVector" begin
    v = SingletonVector(1)
    @test v[1] == first(v) == last(v) == 1
    @test_throws BoundsError v[2]
    @test size(v) == (1,)
    @test collect(v)::Vector{Int} == [1]
    test_shows(v)
end

@testset "SingletonVector as a table" begin
    @testset for T in [
        SingletonVector,
        SingletonVector{Int},
        SingletonVector{<:NamedTuple},
        SingletonVector{NamedTuple},
    ]
        @test !Tables.istable(T)
    end

    @testset for T in [
        SingletonVector{<:NamedTuple{(:a,)}},
        SingletonVector{<:NamedTuple{(:a,),Tuple{Int}}},
    ]
        @test Tables.istable(T)
        @test Tables.rowaccess(T)
        @test Tables.columnaccess(T)
    end

    @testset begin
        @test Tables.rows(SingletonVector((a = 1,))) == [(a = 1,)]
        @test Tables.columns(SingletonVector((a = 1,))) == (a = [1],)
    end
end

@testset "SingletonDict" begin
    d = SingletonDict(:a, 1)
    @test d[:a] == 1
    @test first(d) == last(d) == first(collect(d))
    @test_throws BoundsError d[:non_existing_key]
    @test collect(d)::Vector{Pair{Symbol,Int}} == [:a => 1]
    @test SingletonDict(missing => 1)[missing] === 1
    test_shows(d)
end

end  # module

module BangBangTablesExt

# Uncomment the following code when we move Tables to an extension
#---------------------------
@static if isdefined(Base, :get_extension)
    using BangBang: BangBang
    using BangBang.NoBang: SingletonVector
    using Tables: Tables
else
    using ..BangBang: BangBang
    using ..BangBang.NoBang: SingletonVector
    using ..Tables: Tables
end

# Define table interface as a `SingletonVector{<:NamedTuple}`:
Tables.istable(::Type{<:SingletonVector{<:NamedTuple{names}}}) where {names} =
    @isdefined(names)
Tables.rowaccess(::Type{<:SingletonVector{<:NamedTuple{names}}}) where {names} =
    @isdefined(names)
Tables.columnaccess(::Type{<:SingletonVector{<:NamedTuple{names}}}) where {names} =
    @isdefined(names)

# For backward compatibility (these were automatically `false` in Tables 0.2):
Tables.istable(::Type{SingletonVector{NamedTuple}}) = false
Tables.istable(::Type{SingletonVector{<:NamedTuple}}) = false

Tables.rows(x::SingletonVector{<:NamedTuple}) = [x.value]
Tables.columns(x::SingletonVector{<:NamedTuple{names}}) where {names} =
    NamedTuple{names}(map(x -> [x], Tuple(x.value)))

end

"""
    collector(data::AbstractVector, unsafe::Val = Val(false)) -> c::AbstractCollector
    collector(ElType::Type = Union{}) -> c::AbstractCollector

Create a "collector" `c` that can be used to collect elements; i.e.,
it supports [`append!!`](@ref) and [`push!!`](@ref).  Appending and
pushing elements to a collector are more efficient than doing these
operations directly to a vector.

Use [`finish!(c)`](@ref finish!) to get the collected data as a vector.

`push!!` on the collector can be further optimized by passing
`Val(true)` to the second `unsafe` argument.  This is valid to use
only if the number of elements appended to `c` is less than or equal
to `length(data)`.

# Examples
```jldoctest
julia> using BangBang

julia> c = collector()
       c = push!!(c, 1)
       c = push!!(c, 0.5)
       finish!(c)
2-element Vector{Float64}:
 1.0
 0.5

julia> finish!(append!!(collector(), (x for x in Any[1, 2.0, 3im])))
3-element Vector{ComplexF64}:
 1.0 + 0.0im
 2.0 + 0.0im
 0.0 + 3.0im

julia> finish!(append!!(collector(Vector{Float64}(undef, 10), Val(true)), [1, 2, 3]))
3-element Vector{Float64}:
 1.0
 2.0
 3.0
```
"""
collector
collector(data::AbstractArray, ::Val{false} = Val(false)) = SafeCollector(data)
collector(data::AbstractArray, ::Val{true}) = UnsafeCollector(data)
collector(ElType::Type = Union{}) = SafeCollector(Empty(Vector{ElType}), 1)

abstract type AbstractCollector end

struct SafeCollector{T} <: AbstractCollector
    data::T
    i::Int
end

struct UnsafeCollector{T} <: AbstractCollector
    data::T
    i::Int
end

(::Type{C})(data::AbstractVector) where {C<:AbstractCollector} = C(data, firstindex(data))

# If `c isa UnsafeCollector` and `v` is promotable to
# `eltype(c.data)`, this should compile down to `setindex!`:
@inline push!!(c::AbstractCollector, v) =
    _collect_to!!(c, SingletonVector(v), Base.HasShape{1}(), Base.HasEltype())

@inline __append!!__(c::AbstractCollector, src) =
    _collect_to!!(c, src, Base.IteratorSize(src), Base.IteratorEltype(src))

# ref: jl_array_grow_at_end
_next_length(data, src) = max(4, length(data) + length(src), length(data) * 2)

@inline function _collect_to!!(
    c::AbstractCollector,
    src,
    ::Union{Base.HasShape,Base.HasLength},
    ::Base.HasEltype,
)
    data = c.data
    i = c.i
    if possible(_append!, data, src)
        if c isa UnsafeCollector
            data′ = data
        elseif i + length(src) - 1 > lastindex(data)
            data′ = resize!!(data, _next_length(data, src))
        else
            data′ = data
        end
    else
        T = promote_type(eltype(data), eltype(src))
        if i + length(src) - 1 > lastindex(data)
            data′ = similar(data, T, _next_length(data, src))
        else
            data′ = similar(data, T)
        end
        copyto!(data′, firstindex(data), data, firstindex(data), i - firstindex(data))
    end
    i = let data′ = data′
        foldl(src, init = i) do i, v
            @_inline_meta
            @inbounds data′[i] = v
            return i + 1
        end
    end
    return constructorof(typeof(c))(data′, i)
end

@inline function _collect_to!!(
    c::AbstractCollector,
    src,
    ::Union{Base.HasShape,Base.HasLength},
    ::Base.IteratorEltype,
)
    if c isa UnsafeCollector
        data′′ = c.data
    elseif c.i + length(src) - 1 > lastindex(c.data)
        data′′ = resize!!(c.data, _next_length(c.data, src))
    else
        data′′ = c.data
    end
    data, i = foldl(src, init = (data′′, c.i)) do (data, i), v
        @_inline_meta
        T = promote_type(eltype(data), eltype(v))
        if T <: eltype(data)
            data′ = data
        else
            data′ = similar(data, T)
            copyto!(data′, firstindex(data), data, firstindex(data), i - firstindex(data))
        end
        @inbounds data′[i] = v
        return data′, i + 1
    end
    return constructorof(typeof(c))(data, i)
end

@inline _collect_to!!(
    c::AbstractCollector,
    src,
    ::Base.IteratorSize,
    ::Base.IteratorEltype,
) = foldl(push!!, src, init = c)

@inline __append!!__(c::AbstractCollector, src::AbstractCollector) =
    __append!!__(c, _view(src))

_view(c::AbstractCollector) =
    if c.data isa Empty
        c.data
    else
        @inbounds view(c.data, firstindex(c.data):c.i-1)
    end

"""
    finish!(c::AbstractCollector) -> data::AbstractVector

Extract the `data` collected in the collector `c`.

See [`collector`](@ref).
"""
finish!
finish!(c::AbstractCollector) = resize!!(c.data, c.i - firstindex(c.data))
# Final length is `(c.i - 1) - (firstindex(c.data) - 1)` where the
# first `- 1` is because `c.i` is the index for the next element and
# the second `- 1` is for turning the index to offset.

"""
    may(mutate!, args...)

Call `mutate!(args...)` if possible; fallback to the out-of-place version if not.
"""
may
Base.@propagate_inbounds may(mutate, args...) =
    if possible(mutate, args...)
        mutate(args...)
    else
        pure(mutate)(args...)
    end

_maybb(mutate) = something(_asbb(mutate), mutate)
_asbb(::Any) = nothing

const MaybeMutableContainer = Union{
    AbstractArray,
    AbstractDict,
    AbstractSet,
}
const ShapeFrozenContainer = Union{
    NoBang.ImmutableContainer,
    NoBang.Empty,
    NoBang.SingletonVector,
    NoBang.SingletonDict,
}
const Mutator = Union{typeof(push!), typeof(setindex!)}

"""
    implements(f!, x) :: Bool

`true` if in-place function `f!` can mutate `x`.

# Examples
```jldoctest
julia> using BangBang: implements

julia> implements(push!, Vector)
true

julia> implements(push!, [])  # works with instances, too
true

julia> implements(push!, Tuple)
false

julia> using StaticArrays

julia> implements(push!, SVector)
false

julia> implements(setindex!, SVector)
false

julia> implements(push!, MVector)
false

julia> implements(setindex!, MVector)
true
```
"""
implements
implements(f!, x) = implements(f!, typeof(x))
implements(::Any, ::Type) = false

implements(::Mutator, ::Type{<:ShapeFrozenContainer}) = false
implements(::Mutator, ::Type{<:MaybeMutableContainer}) = true
implements(::Mutator, ::Type{<:AbstractString}) = false

implements(::typeof(resize!), ::Type{<:AbstractVector}) = true
implements(
    ::typeof(resize!),
    ::Type{<:Union{SubArray{<:Any,1},Base.ReshapedArray{<:Any,1}}},
) = false

if !@isdefined(ismutabletype)
    Base.@pure ismutabletype(T::DataType) = T.mutable
end
implements(::typeof(setproperty!), T::DataType) = ismutabletype(T)
implements(::typeof(setproperty!), ::Type{<:NamedTuple}) = false

# trymutate(::typeof(push!)) = push!!
# trymutate(::typeof(append!)) = append!!

struct Undefined end
implements(::Mutator, ::Undefined) = false
Base.broadcastable(x::Undefined) = Ref(x)

"""
    possible(f!, args...) :: Bool

Check if `f!(args...)` is possible.

# Examples
```jldoctest
julia> using BangBang: possible

julia> possible(push!, Int[], 1)
true

julia> possible(push!, Int[], 0.5)
false
```
"""
possible

module BenchCollectors

using BangBang: Empty, collector, finish!, push!!
using BenchmarkTools: @benchmarkable, BenchmarkGroup
using SplittablesBase: amount

function map_manual(f, src)
    dest = similar(src)
    for i in eachindex(src, dest)
        @inbounds dest[i] = f(src[i])
    end
    return dest
end

function map_collector(f, src, unsafe = Val(true))
    dest = similar(src)
    c = collector(dest, unsafe)
    for x in src
        c = push!!(c, f(x))
    end
    return finish!(c)
end

function map_vector(f, src)
    dest = eltype(src)[]
    for x in src
        dest = push!!(dest, f(x))
    end
    return dest
end

@inline function _foldl(op, acc::T, itr) where {T}
    y = iterate(itr)
    y === nothing && return acc
    (x, state) = y
    result = op(acc, x)
    if result isa T
        return _foldl(op, result, itr, state)
    else
        return _foldl(op, result, itr, state)
    end
end

@inline function _foldl(op, acc::T, itr, state) where {T}
    while true
        y = iterate(itr, state)
        y === nothing && return acc
        (x, state) = y
        result = op(acc, x)
        if result isa T
            acc = result
        else
            return _foldl(op, result, itr, state)
        end
    end
end

collect_collector(src) = finish!(_foldl(push!!, collector(), src))

collect_vector(src) = _foldl(push!!, Empty(Vector), src)

collect_collector_nonexpanding(src) =
    finish!(_foldl(push!!, collector(resize!(Union{}[], amount(src)), Val(true)), src))

double(x) = 2 * x

suite = BenchmarkGroup()

let s0 = suite[:comp=>"map"] = BenchmarkGroup()
    xs = 1:10_000
    @assert map_manual(double, xs) == map_collector(double, xs) == map_vector(double, xs)
    s0[:impl=>"man"] = @benchmarkable(map_manual(double, $xs))
    s0[:impl=>"coll"] = @benchmarkable(map_collector(double, $xs))
    s0[:impl=>"safe_coll"] = @benchmarkable(map_collector(double, $xs, Val(false)))
    s0[:impl=>"vec"] = @benchmarkable(map_vector(double, $xs))
end

let s0 = suite[:comp=>"filter"] = BenchmarkGroup()
    xs = (x for x in 1:10_000 if isodd(x))
    @assert collect(xs) ==
            collect_collector(xs) ==
            collect_vector(xs) ==
            collect_collector_nonexpanding(xs)
    s0[:impl=>"base"] = @benchmarkable(collect($xs))
    s0[:impl=>"coll"] = @benchmarkable(collect_collector($xs))
    s0[:impl=>"vec"] = @benchmarkable(collect_vector($xs))
    s0[:impl=>"nonexpanding"] = @benchmarkable(collect_collector_nonexpanding($xs))
end

end  # module
BenchCollectors.suite

module TestInitialValues

include("preamble.jl")
using InitialValues: InitialValue, hasinitialvalue

@testset begin
    @test hasinitialvalue(push!!)
    @test hasinitialvalue(append!!)
    @test push!!(InitialValue(push!!), 1) == [1]
    @test append!!(InitialValue(append!!), [1]) == [1]
    @test append!!([1], InitialValue(append!!)) == [1]
end

end  # module

module TestAppend

include("preamble.jl")

using BangBang.NoBang: SingletonVector
using InitialValues: InitialValue, asmonoid
using StructArrays: StructVector

@testset begin
    @test append!!([0.0], [1.0]) == [0.0, 1.0]
    @test append!!([0], [1.0]) == [0.0, 1.0]
    @test append!!([0], (1.0,)) == [0.0, 1.0]
    @test append!!((0,), (1,)) === (0, 1)
    @test append!!((a=0,), pairs((b=1,))) === (a=0, b=1)
    @test append!!(ImmutableDict(:a=>1), ImmutableDict(:b=>2)) ==
        ImmutableDict(ImmutableDict(:a=>1), :b=>2)
    @test append!!("a", "b") === "ab"
    @test append!!(SVector(0), [1])::Vector == [0, 1]
    @test append!!([0], SVector(1))::Vector == [0, 1]
    @test append!!(Union{}[], Iterators.take(1:10, 3)) ==ₜ [1, 2, 3]
    @test append!!(SingletonVector(1), [0.5, 2]) ==ₜ [1, 0.5, 2]
end

@testset "Init" begin
    xs = [1, 2, 3]
    @test append!!(xs, InitialValue(append!!)) === xs
    @test append!!(InitialValue(append!!), xs) !== xs
    @test append!!(InitialValue(append!!), xs) ==ₜ xs
    @test append!!(InitialValue(append!!), (x for x in xs if true)) ==ₜ xs
    @test append!!(InitialValue(append!!), InitialValue(append!!)) === InitialValue(append!!)
    @test asmonoid(append!!) === append!!
end

@testset "Empty" begin
    @testset "`append!!` must create a new collection" begin
        xs = [1]
        @test append!!(Empty(Vector), xs) !== xs
        @test append!!(Empty(Vector), xs) == xs
    end
    @testset "append!!(::Empty, ::Empty) :: Empty" begin
        @test append!!(Empty(Vector), Empty(Vector)) === Empty(Vector)
        @test append!!(Empty(Vector), Empty(Dict)) === Empty(Vector)
        @test append!!(Empty(Dict), Empty(Vector)) === Empty(Dict)
    end
    @testset "append!!(x, ::Empty) == x" begin
        x = [0]
        @test append!!(x, Empty(Vector)) === x == [0]
    end
    @testset "`mapreduce`" begin
        @test mapreduce(
            SingletonVector,
            append!!,
            Any[1, 2, 3];
            init = Empty(Vector),
        ) ==ₜ [1, 2, 3]

        @test mapreduce(
            x -> SingletonVector((a = x, b = x^2)),
            append!!,
            [1, 2, 3];
            init = Empty(StructVector),
        ) ==ₜ StructVector(a = [1, 2, 3], b = [1, 2, 3] .^ 2)
    end
end

end  # module

module TestIR

# TODO: maybe re-enable these if someone has the motivation to rewrite them to work on
# modfern julia versions:

#using PerformanceTestTools
#PerformanceTestTools.@include("__test_ir.jl")

end  # module

module TestPopfirst

include("preamble.jl")

@testset begin
    @test popfirst!!([0, 1]) == ([1], 0)
    @test popfirst!!((0, 1)) === ((1,), 0)
    @test popfirst!!((a=0, b=1)) === ((b=1,), 0)
    @test popfirst!!(SVector(0, 1)) === (SVector(1), 0)
end

@testset "mutation" begin
    @testset for xs in [
        [0, 1],
    ]
        @test popfirst!!(xs)[1] === xs
    end
end

end  # module

using Documenter, BangBang

makedocs(
    ;
    modules = [BangBang],
    format = Documenter.HTML(),
    pages = [
        "Home" => "index.md",
        hide("internals.md"),
    ],
    repo = "https://github.com/JuliaFolds2/BangBang.jl/blob/{commit}{path}#L{line}",
    sitename = "BangBang.jl",
    authors = "Takafumi Arakaki <aka.tkf@gmail.com>",
    doctest = false,  # run via tests
    warnonly = Documenter.except(
        :autodocs_block,
        :cross_references,
        :docs_block,
        :doctest,
        :eval_block,
        :example_block,
        :footnote,
        :linkcheck,
        :meta_block,
        # Ignoring `:missing_docs` since Documenter does not handle docstrings
        # defined outside the sub-module nicely:
        # :missing_docs,
        :parse_error,
        :setup_block,
    ),
    # Ref:
    # https://juliadocs.github.io/Documenter.jl/stable/lib/public/#Documenter.makedocs
)

deploydocs(; repo = "github.com/JuliaFolds2/BangBang.jl", push_preview = true)

module TestSetIndex

include("preamble.jl")

# Some utility methods for testing `setindex!`.
test_linear_index_only(::Tuple, ::AbstractArray) = false
test_linear_index_only(inds::NTuple{1}, ::AbstractArray) = true
test_linear_index_only(inds::NTuple{1}, ::AbstractVector) = false

replace_colon_with_axis(inds::Tuple, x) = ntuple(length(inds)) do i
    inds[i] isa Colon ? axes(x, i) : inds[i]
end
replace_colon_with_vector(inds::Tuple, x) = ntuple(length(inds)) do i
    inds[i] isa Colon ? collect(axes(x, i)) : inds[i]
end
replace_colon_with_range(inds::Tuple, x) = ntuple(length(inds)) do i
    inds[i] isa Colon ? (1:size(x, i)) : inds[i]
end
replace_colon_with_booleans(inds::Tuple, x) = ntuple(length(inds)) do i
    inds[i] isa Colon ? trues(size(x, i)) : inds[i]
end

replace_colon_with_range_linear(inds::NTuple{1}, x::AbstractArray) = inds[1] isa Colon ? (1:length(x),) : inds

@testset begin
    @test setindex!!((1, 2, 3), :two, 2) === (1, :two, 3)
    @test setindex!!((a=1, b=2, c=3), :two, :b) === (a=1, b=:two, c=3)
    @test setindex!!([1, 2, 3], :two, 2) == [1, :two, 3]
    @test setindex!!(Dict{Symbol,Int}(:a=>1, :b=>2), 10, :a) ==
        Dict(:a=>10, :b=>2)
    @test setindex!!(Dict{Symbol,Int}(:a=>1, :b=>2), 3, "c") ==
        Dict(:a=>1, :b=>2, "c"=>3)
end

@testset "mutation" begin
    @testset "without type expansion" begin
        for args in [
            ([1, 2, 3], 20, 2),
            (Dict(:a => 1, :b => 2), 10, :a),
            ([(1,),(2,),(3,)], [(4,), (5,), (6,)], :, 1)
        ]
            @test setindex!!(args...) === args[1]
        end
    end

    @testset "with type expansion" begin
        @test setindex!!([1, 2, 3], [4, 5], 1) == [[4, 5], 2, 3]
        @test setindex!!([1, 2, 3], [4, 5, 6], :, 1) == [4, 5, 6]
    end

    @testset "should mutate" begin
        # Ref: https://github.com/JuliaFolds2/BangBang.jl/issues/21
        xs = Vector{Vector{Float64}}(undef, 2)
        setindex!!(xs, [1.0], 1)
        @test xs[1] == [1.0]

        xs = Vector(undef, 2)
        setindex!!(xs, 1.0, 1)
        @test xs[1] == 1.0
    end
end

@testset "slices" begin
    @testset "$(typeof(x)) with $(src_idx)" for (x, src_idx) in [
        # Vector.
        (randn(2), (:,)),
        (randn(2), (1:2,)),
        # Matrix.
        (randn(2, 3), (:,)),
        (randn(2, 3), (:, 1)),
        (randn(2, 3), (:, 1:3)),
        # 3D array.
        (randn(2, 3, 4), (:, 1, :)),
        (randn(2, 3, 4), (:, 1:3, :)),
        (randn(2, 3, 4), (1, 1:3, :)),
    ]
        # Base case.
        @test @inferred(setindex!!(x, x[src_idx...], src_idx...)) === x

        # If we have `Colon` in the index, we replace this with other equivalent indices.
        if any(Base.Fix2(isa, Colon), src_idx)
            if test_linear_index_only(src_idx, x)
                # With range instead of `Colon`.
                @test @inferred(setindex!!(x, x[src_idx...], replace_colon_with_range_linear(src_idx, x)...)) === x
            else
                # With axis instead of `Colon`.
                @test @inferred(setindex!!(x, x[src_idx...], replace_colon_with_axis(src_idx, x)...)) === x
                # With range instead of `Colon`.
                @test @inferred(setindex!!(x, x[src_idx...], replace_colon_with_range(src_idx, x)...)) === x
                # With vectors instead of `Colon`.
                @test @inferred(setindex!!(x, x[src_idx...], replace_colon_with_vector(src_idx, x)...)) === x
                # With boolean index instead of `Colon`.
                @test @inferred(setindex!!(x, x[src_idx...], replace_colon_with_booleans(src_idx, x)...)) === x
            end
        end
    end
end

end  # module

module BangBangStaticArraysExt
@static if isdefined(Base, :get_extension)
    using BangBang: BangBang
    using BangBang.NoBang: NoBang
    using BangBang: setindex!
    using StaticArrays: StaticArrays
else
    using ..BangBang: BangBang
    using ..BangBang.NoBang: NoBang
    using ..BangBang: setindex!
    using ..StaticArrays: StaticArrays
end


    NoBang.push(xs::StaticArrays.StaticVector, x) = vcat(xs, StaticArrays.SVector(x))
    NoBang.pushfirst(xs::StaticArrays.StaticVector, x) = StaticArrays.pushfirst(xs, x)
    NoBang.pushfirst(xs::StaticArrays.StaticVector, y, ys...) =
    foldl(NoBang.pushfirst, (reverse(ys)..., y), init=xs)
    NoBang.pop(xs::StaticArrays.StaticVector) = (StaticArrays.pop(xs), xs[end])
    NoBang.popfirst(xs::StaticArrays.StaticVector) = (StaticArrays.popfirst(xs), xs[1])
    NoBang.deleteat(xs::StaticArrays.StaticVector, i) = StaticArrays.deleteat(xs, i)
    NoBang._empty(xs::StaticArrays.StaticVector) =
    foldl(ntuple(identity, length(xs)); init=xs) do xs, _
        StaticArrays.pop(xs)
    end
    NoBang._setindex(xs::StaticArrays.StaticArray, v, I...) = Base.setindex(xs, v, I...)

    StaticArrays.SArray(x::NoBang.SingletonVector) = StaticArrays.SVector{1}(x)
    StaticArrays.SVector(x::NoBang.SingletonVector) = StaticArrays.SVector{1}(x)
    StaticArrays.MArray(x::NoBang.SingletonVector) = StaticArrays.MVector{1}(x)
    StaticArrays.MVector(x::NoBang.SingletonVector) = StaticArrays.MVector{1}(x)


    BangBang.implements(::BangBang.Mutator, ::Type{<:StaticArrays.StaticArray}) = false
    BangBang.implements(::typeof(setindex!), ::Type{<:StaticArrays.MArray}) = true
    BangBang.implements(::typeof(setindex!), ::Type{<:StaticArrays.SizedArray}) = true
    BangBang.copyappendable(src::StaticArrays.StaticVector) = src
end

module TestEmptyProxy

include("preamble.jl")

==ₜₗ(_, _) = false
==ₜₗ(x::T, y::T) where {T} = length(x) == length(y)

@testset begin
    @test collect(Empty(Vector)) == Union{}[]
    @test collect(Empty(Dict)) == Union{}[]
    @test collect(Empty(Set)) == Union{}[]
end

@testset "similar" begin
    @test similar(Empty(Vector)) ==ₜ Union{}[]
    @test similar(Empty(Vector{Union{}})) ==ₜ Union{}[]
    @test similar(Empty(Vector{Int})) ==ₜ Int[]
    @test similar(Empty(Vector), Int) ==ₜ Int[]
    @test similar(Empty(Vector{Union{}}), Int) ==ₜ Int[]
    @test similar(Empty(Vector{Int}), Symbol) ==ₜ Symbol[]

    @test similar(Empty(Vector), 3) ==ₜₗ resize!(Union{}[], 3)
    @test similar(Empty(Vector{Union{}}), 3) ==ₜₗ resize!(Union{}[], 3)
    @test similar(Empty(Vector{Int}), 3) ==ₜₗ resize!(Int[], 3)
    @test similar(Empty(Vector), Int, 3) ==ₜₗ resize!(Int[], 3)
    @test similar(Empty(Vector{Union{}}), Int, 3) ==ₜₗ resize!(Int[], 3)
    @test similar(Empty(Vector{Int}), Symbol, 3) ==ₜₗ resize!(Symbol[], 3)

    @test similar(Empty(Vector), (3,)) ==ₜₗ resize!(Union{}[], 3)
    @test similar(Empty(Vector{Union{}}), (3,)) ==ₜₗ resize!(Union{}[], 3)
    @test similar(Empty(Vector{Int}), (3,)) ==ₜₗ resize!(Int[], 3)
    @test similar(Empty(Vector), Int, (3,)) ==ₜₗ resize!(Int[], 3)
    @test similar(Empty(Vector{Union{}}), Int, (3,)) ==ₜₗ resize!(Int[], 3)
    @test similar(Empty(Vector{Int}), Symbol, (3,)) ==ₜₗ resize!(Symbol[], 3)
end

@testset "Empty(Dict)" begin
    @test !haskey(Empty(Dict), :key)
end

end  # module

module TestRmul

include("preamble.jl")
using LinearAlgebra

@testset begin
    @test rmul!!(1, 2) === 2

    A = collect(Float64, reshape(1:4, 2, 2))
    B = UpperTriangular(ones(2, 2))
    AB = A * B
    @test rmul!!(A, B) === A
    @test A == AB
    @test_inferred rmul!!(A, B)

    A = collect(Int, reshape(1:4, 2, 2))
    B = UpperTriangular(ones(2, 2))
    AB = A * B
    @test rmul!!(A, B) :: Matrix{Float64} == AB
    @test_inferred rmul!!(A, B)
end

end  # module

module TestDataFrames

using BangBang: append!!, push!!, setindex!!
using CategoricalArrays: CategoricalArray
using DataFrames: DataFrame
using InitialValues: InitialValue
using Tables: Tables
using Test

@testset "push!!" begin
    @testset "column: $(typeof(column)); row: $(typeof(row))" for (column, row) in [
        ([0], (a = 1,)),
        ([0], Dict(:a => 1)),
        ([0], [1]),
        ([0], (1,)),
        ([0.5], (a = 1,)),
        ([0.5], Dict(:a => 1)),
        ([0.5], [1]),
        ([0.5], (1,)),
        ([0], (a = 1.5,)),
        (CategoricalArray(["A", "B"]), (a = "A",)),
        (CategoricalArray(["A", "B"]), (a = "C",)),
    ]
        df = DataFrame(a = copy(column))
        # row isa DataFrame
        # row[:, :a] .+= 1
        if row isa Union{Array, Tuple}
            df2 = DataFrame(a=row[1])
        else
            df2 = DataFrame([(; pairs(row)...)])
        end
        @test push!!(copy(df), row) == vcat(df, df2)
        @test push!(push!!(copy(df), row), row) isa DataFrame
    end
end

@testset "push!!(::DataFrame, ::IteratorRow)" begin
    @testset "column: $(typeof(column)); row: $(typeof(row))" for (column, row) in [
        ([0], Tables.IteratorRow((a = 1,))),
        ([0.5], Tables.IteratorRow((a = 1,))),
    ]
        df = DataFrame(a = copy(column))
        df2 = DataFrame([(a = 1,)])
        @test push!!(copy(df), row) == vcat(df, df2)
    end
end

@testset "append!!" begin
    @testset "column: $(typeof(column)); source: $(typeof(source))" for (
        column,
        source,
    ) in [
        ([0], ((a = 1,),)),
        ([0], [(a = 1,)]),
        ([0], (a = [1],)),
        # ([0], Dict(:a => [1])),
        ([0], DataFrame(a = [1])),
        ([0.5], ((a = 1,),)),
        ([0.5], [(a = 1,)]),
        ([0.5], (a = [1],)),
        ([0.5], DataFrame(a = [1])),
        ([0], ((a = 1.5,),)),
        ([0], [(a = 1.5,)]),
        ([0], (a = [1.5],)),
        ([0], DataFrame(a = [1.5])),
        (CategoricalArray(["A", "B"]), ((a = "A",),)),
        (CategoricalArray(["A", "B"]), [(a = "A",)]),
        (CategoricalArray(["A", "B"]), (a = ["A"],)),
        (CategoricalArray(["A", "B"]), ((a = "C",),)),
        (CategoricalArray(["A", "B"]), [(a = "C",)]),
        (CategoricalArray(["A", "B"]), (a = ["C"],)),
    ]
        df = DataFrame(a = copy(column))
        # source isa DataFrame
        # source[:, :a] .+= 1
        @test append!!(copy(df), source) == vcat(df, DataFrame(source))
    end
    @testset "Init" begin
        src = DataFrame(a=[1])
        dest = append!!(InitialValue(append!!), src)
        @test src == dest
        src.a[1] = 123
        @test src != dest
    end
end

@testset "setindex!!" begin
    @testset "in-place $row" for (row, new_val) in [
        (1, 2.0),
        (1:2, [2.0, 3.0]),
        (Colon(), [2.0, 3.0]),
        ([1], [2.0]),
    ]
        @testset "$col" for col in ["a", :a, 1]
            df = DataFrame("a" => [0.0, 1.0])
            @test setindex!!(df, new_val, row, col) === df
            @test df[row, col] == new_val
        end
    end

    @testset "in-place $row" for (row, new_val) in [
        (1, 2.0),
        (1:2, [2.0, 3.0]),
        (Colon(), [2.0, 3.0]),
        ([1], [2.0]),
    ]
        @testset "$col" for col in ["a", :a, 1]
            # Start with integers
            df = DataFrame("a" => [0, 1])
            # Even though setindex!! will create a new array, it should still modify `df`
            # itself in-place.
            @test setindex!!(df, new_val, row, col) === df
            @test df[row, col] == new_val
            if row isa Integer
                @test eltype(df.a) === Float64
            else
                # This should in principle also be Float64 but isn't due to
                # https://github.com/JuliaFolds2/BangBang.jl/issues/39
                @test eltype(df.a) === Any
            end
        end
    end
end

end  # module

module TestUnique

include("preamble.jl")

@testset begin
    @test unique!!([3, 2, 1, 2, 3]) == [3, 2, 1]
    @test unique!!(x for x in [3, 2, 1, 2, 3]) == [3, 2, 1]
end

@testset "mutation" begin
    @testset "Vector" begin
        x = [3, 2, 1, 2, 3]
        y = unique(x)
        @test unique!!(x) === x == y
    end
    @testset "Set" begin
        x = Set([0])
        @test unique!!(x) === x
    end
end

end  # module

module TestUnion

include("preamble.jl")
using BangBang: SingletonVector
using InitialValues: InitialValue, asmonoid

@testset begin
    @test_returns_first union!!([0]) == [0]
    @test_returns_first union!!(Set([0])) == Set([0])
    @test union!!([0.0], [1.0]) ==ₜ [0.0, 1.0]
    @test union!!([0], [0.5]) ==ₜ [0.0, 0.5]
    @test union!!(Set([0.0]), [1.0]) ==ₜ Set([0.0, 1.0])
    @test union!!(Set([0]), [0.5]) ==ₜ Set([0.0, 0.5])
    @test union!!(Empty(Set), [0]) ==ₜ Set([0])
    @test union!!(Empty(Set), SingletonVector(0)) ==ₜ Set([0])
end

@testset "Empty" begin
    @testset "union!!(::Empty, ::Empty) :: Empty" begin
        @test union!!(Empty(Set), Empty(Set)) === Empty(Set)
        @test union!!(Empty(Set), Empty(Vector)) === Empty(Set)
    end
    @test union!!(Empty(Set)) === Empty(Set)
end

@testset "mutation" begin
    @testset "Vector" begin
        x = [0.0]
        @test union!!(x, [1]) === x
        @test x ==ₜ [0.0, 1.0]
    end
    @testset "Set" begin
        x = Set([0.0])
        @test union!!(x, [1]) === x
        @test x ==ₜ Set([0.0, 1.0])
    end
end

@testset "InitialValue" begin
    xs = Set([0])
    @test union!!(xs, InitialValue(union!!)) === xs
    @test union!!(InitialValue(union!!), xs) !== xs
    @test union!!(InitialValue(union!!), xs) ==ₜ xs
    @test union!!(InitialValue(union!!), (x for x in xs if true)) ==ₜ xs
    @test union!!(InitialValue(union!!), InitialValue(union!!)) === InitialValue(union!!)
    @test asmonoid(union!!) === union!!
end

end  # module

module TestCollectors

include("preamble.jl")

@testset "stable eltype" begin
    @testset for unsafe in [false, true]
        n = 10
        @testset "$label" for (label, src) in [
            "vector" => 1:n,
            "generator" => (x + 1 for x in 1:n),
            "filter" => (x for x in 1:n if isodd(x)),
        ]
            data = Vector{Int}(undef, n)
            c = collector(data, Val(unsafe))
            @test finish!(append!!(c, src)) === data
            @test data == collect(src)
        end
    end
end

@testset "unstable eltype" begin
    @testset for unsafe in [false, true]
        n = 10
        @testset "$label" for (label, src) in [
            "generator" => (x > 5 ? nothing : x for x in 1:n),
            "filter" => (x > 5 ? nothing : x for x in 1:n if isodd(x)),
        ]
            data = Vector{Int}(undef, n)
            c = collector(data, Val(unsafe))
            result = finish!(append!!(c, src))
            @test result !== data
            @test result == collect(src)
            @test data[1] == 1
        end
    end
end

@testset "combine" begin
    c1 = append!!(collector(), [1, 2])
    c2 = append!!(collector(), [3, 4, 5])
    @test finish!(append!!(c1, c2)) == 1:5

    @test finish!(append!!(collector(), collector())) ==ₜ Union{}[]
end

@testset "Empty" begin
    @test finish!(append!!(collector(), Union{}[])) ==ₜ Union{}[]
    @test finish!(append!!(collector(), ())) ==ₜ Union{}[]
end

end  # module

module TestIntersect

include("preamble.jl")
# using MicroCollections: SingletonSet

@testset begin
    @test_returns_first intersect!!([0]) == [0]
    @test_returns_first intersect!!(Set([0])) == Set([0])
    @test_returns_first intersect!!([0], [1]) == []
    @test_returns_first intersect!!([0], (1,)) == []
    @test_returns_first intersect!!([0, 1, 2], (0, 1), [1, 2]) == [1]
    @test_returns_first intersect!!(Set([0]), [0]) == Set([0])
    @test_returns_first intersect!!(Set([0]), (0,)) == Set([0])
    @test_returns_first intersect!!(Set([0, 1, 2]), Set([0,1]), [1, 2]) == Set([1])
    @test intersect!!(Empty(Set)) === Empty(Set)
    @test intersect!!(Empty(Vector), Empty(Set)) === Empty(Vector)
    @test intersect!!(Empty(Vector), [0]) === Empty(Vector)
    @test intersect!!(Empty(Set{Int}), [0]) === Empty(Set{Int})
    #=
    @test intersect!!(SingletonSet((0,)), [0]) ==ₜ Set([0])
    @test intersect!!(SingletonSet((0,)), [1]) ==ₜ Set{Int}()
    =#
end

end  # module

"""
    BangBang.Extras

`BangBang` APIs that have no counterparts in `Base`.
"""
module Extras

export mergewith!!, modify!!, broadcast_inplace!!

using ..BangBang: delete!!, setindex!!, mergewith!!

"""
    modify!!(f, dictlike, key) -> (dictlike′, ret)

Lookup and then update, insert or delete in one go.  If supported
(e.g., when `dictlike isa Dict`), it is done without re-computing the
hash.  Immutable containers like `NamedTuple` is also supported.

The callable `f` must accept a single argument of type
`Union{Some{valtype(dictlike)}, Nothing}`.  The value
`Some(dictlike[key])` is passed to `f` if `haskey(dictlike, key)`;
otherwise `nothing` is passed.

If `f` returns `nothing`, corresponding entry in the dictionary
`dictlike` is removed.  If `f` returns non-`nothing` value `x`, `key
=> something(x)` is inserted to `dictlike` (equivalent to
`dictlike[key] = something(x)` but more efficient).

`modify!!` returns a 2-tuple `(dictlike′, ret)` where `dictlike′` is
an updated version of `dictlike` (which may be identical to
`dictlike`) and `ret` is the returned value of `f`.

This API is inspired by
[`Control.Lens.At`](http://hackage.haskell.org/package/lens-4.17.1/docs/Control-Lens-At.html)
of Haskell's lens library.

# Examples
```jldoctest
julia> using BangBang.Extras: modify!!

julia> dict = Dict("a" => 1);

julia> dict′, ret = modify!!(dict, "a") do val
           Some(something(val, 0) + 1)
       end;

julia> ret
Some(2)

julia> dict === dict′
true

julia> dict
Dict{String, Int64} with 1 entry:
  "a" => 2

julia> dict = Dict();

julia> modify!!(dict, "a") do val
           Some(something(val, 0) + 1)
       end;

julia> dict
Dict{Any, Any} with 1 entry:
  "a" => 1

julia> modify!!(_ -> nothing, dict, "a");

julia> dict
Dict{Any, Any}()
```

# Discussion

* [Add modify! function for lookup/update/insert/delete in one go by tkf · Pull Request #33758 · JuliaLang/julia](https://github.com/JuliaLang/julia/pull/33758)
* [Support adding to named tuples? · Issue #65 · jw3126/Setfield.jl](https://github.com/jw3126/Setfield.jl/issues/65)
"""
modify!!

modify!!(f, dict, key) = generic_modify!!(f, dict, key)

function generic_modify!!(f, dict, key)
    if haskey(dict, key)
        val = f(Some(dict[key]))
    else
        val = f(nothing)
    end
    if val === nothing
        dict′ = delete!!(dict, key)
    else
        dict′ = setindex!!(dict, something(val), key)
    end
    return (dict′, val)
end

function modify!!(f, h::Dict{K1}, key0::K2) where {K1, K2}
    promote_type(K1, K2) <: K1 || return generic_modify!!(f, h, key0)
    key = convert(K1, key0)
    isequal(key, key0) || return generic_modify!!(f, h, key0)

    # Ideally, to improve performance for the case that requires
    # resizing, we should use something like `ht_keyindex` while
    # keeping computed hash value and then do something like
    # `ht_keyindex2!` if `f` returns non-`nothing`.
    idx = Base.ht_keyindex2!(h, key)

    age0 = h.age
    found = false
    if idx > 0
        found = true
        @inbounds vold = h.vals[idx]
        vnew = f(Some(vold))
    else
        vnew = f(nothing)
    end
    if h.age != age0
        idx = Base.ht_keyindex2!(h, key)
    end

    if vnew === nothing
        if idx > 0
            Base._delete!(h, idx)
        end
    else
        val = something(vnew)
        if !(K1 isa String)
            if found && val === vold
                return (h, vnew)  # nothing to do (optimization)
            end
        end
        if !(typeof(val) <: eltype(h.vals))
            return setindex!!(h, val, key0), vnew
        end
        if idx > 0
            h.age += 1
            @inbounds h.keys[idx] = key
            @inbounds h.vals[idx] = val
        else
            @inbounds Base._setindex!(h, val, key, -idx)
        end
    end
    return (h, vnew)
end

function broadcast_inplace!! end

end  # module

# `Extras` was called `Experimental` before
const Experimental = Extras

"""
    push!!(collection, items...)

Push one or more `items` to collection.  Create a copy of `collection`
if it cannot be mutated or the element type does not match.

# Examples
```jldoctest
julia> using BangBang

julia> push!!((1, 2), 3)
(1, 2, 3)

julia> push!!([1, 2], 3)
3-element Vector{Int64}:
 1
 2
 3

julia> push!!([1, 2], 3.0)
3-element Vector{Float64}:
 1.0
 2.0
 3.0

julia> using StaticArrays: SVector

julia> @assert push!!(SVector(1, 2), 3.0) === SVector(1.0, 2.0, 3.0)

julia> using DataFrames: DataFrame

julia> @assert push!!(DataFrame(a=[1], b=[2]), (a=3.5, b=4.5)) ==
           DataFrame(a=[1.0, 3.5], b=[2.0, 4.5])

julia> using StructArrays: StructVector

julia> @assert push!!(StructVector(a=[1], b=[2]), (a=3.5, b=4.5)) ==
           StructVector(a=[1.0, 3.5], b=[2.0, 4.5])

julia> using TypedTables: Table

julia> @assert push!!(Table(a=[1], b=[2]), (a=3.5, b=4.5)) ==
           Table(a=[1.0, 3.5], b=[2.0, 4.5])
```
"""
push!!
push!!(xs, i1, i2, items...) =
    foldl(push!!, items, init=push!!(push!!(xs, i1), i2))
push!!(xs, x) = may(push!, xs, x)

pure(::typeof(push!)) = NoBang.push
_asbb(::typeof(push!)) = push!!
possible(::typeof(push!), x, ::Any) = implements(push!, x)
possible(::typeof(push!), ::C, ::S) where {C <: MaybeMutableContainer, S} =
    implements(push!, C) && promote_type(eltype(C), S) <: eltype(C)

"""
    append!!(dest, src) -> dest′

Append items in `src` to `dest`.  Mutate `dest` if possible.

This function "owns" `dest` but not `src`; i.e., returned value
`dest′` does not alias `src`.  For example, `append!!(Empty(Vector),
src)` shallow-copies `src` instead of returning `src` as-is.

See also [`push!!`](@ref).

# Examples
```jldoctest
julia> using BangBang

julia> append!!((1, 2), (3, 4))
(1, 2, 3, 4)

julia> append!!([1, 2], (3, 4))
4-element Vector{Int64}:
 1
 2
 3
 4

julia> using StaticArrays: SVector

julia> @assert append!!(SVector(1, 2), (3, 4)) === SVector(1, 2, 3, 4)

julia> using DataFrames: DataFrame

julia> @assert append!!(DataFrame(a=[1], b=[2]), [(a=3.0, b=4.0)]) ==
           DataFrame(a=[1.0, 3.0], b=[2.0, 4.0])

julia> using StructArrays: StructVector

julia> @assert append!!(StructVector(a=[1], b=[2]), [(a=3.5, b=4.5)]) ==
           StructVector(a=[1.0, 3.5], b=[2.0, 4.5])

julia> using TypedTables: Table

julia> @assert append!!(Table(a=[1], b=[2]), [(a=3.5, b=4.5)]) ==
           Table(a=[1.0, 3.5], b=[2.0, 4.5])
```

`append!!` does not own the second argument:

```jldoctest; setup = :(using BangBang)
julia> xs = [1, 2, 3];

julia> ys = append!!(Empty(Vector), xs)
3-element Vector{Int64}:
 1
 2
 3

julia> ys === xs
false
```
"""
append!!
@inline append!!(xs, ys) = __append!!__(xs, ys)

"""
    __append!!__(dest::CustomType, src) -> dest′

This is an overload interface for `append!!`.  This function must
dispatch on the first argument and implemented by the owner of the
type of the first argument.
"""
__append!!__
@inline __append!!__(xs, ys) = __appendto!!__(xs, ys)

"""
    __appendto!!__(dest, src::CustomType) -> dest′

This is an overload interface for `append!!`.  This function must
dispatch on the second argument and implemented by the owner of the
type of second first argument.  This function is used when there is
no specific implementation for [`__append!!__`](@ref) is found.
"""
__appendto!!__
@inline __appendto!!__(xs, ys) = may(_append!, xs, ys)

# An indirection for supporting dispatch on the second argument.
_append!(dest, src) = append!(dest, src)
_append!(dest, src::SingletonVector) = push!(dest, src.value)

pure(::typeof(_append!)) = NoBang.append
_asbb(::typeof(append!)) = append!!
possible(::typeof(_append!), x, ::Any) = implements(push!, x)
possible(::typeof(_append!), ::C, ys) where {C <: MaybeMutableContainer} =
    implements(push!, C) && promote_type(eltype(C), eltype(ys)) <: eltype(C)

"""
    pushfirst!!(collection, items...)

# Examples
```jldoctest
julia> using BangBang

julia> pushfirst!!((1, 2), 3, 4)
(3, 4, 1, 2)

julia> pushfirst!!([1, 2], 3, 4)
4-element Vector{Int64}:
 3
 4
 1
 2

julia> pushfirst!!([1, 2], 3, 4.0)
4-element Vector{Float64}:
 3.0
 4.0
 1.0
 2.0

julia> using StaticArrays: SVector

julia> @assert pushfirst!!(SVector(1, 2), 3, 4) === SVector(3, 4, 1, 2)
```
"""
pushfirst!!
pushfirst!!(xs, ys...) = may(pushfirst!, xs, ys...)

pure(::typeof(pushfirst!)) = NoBang.pushfirst
_asbb(::typeof(pushfirst!)) = pushfirst!!
possible(::typeof(pushfirst!), ::Tuple, ::Vararg) = false
possible(::typeof(pushfirst!), ::C, ys...) where {C <: AbstractVector} =
    implements(push!, C) && promote_type(eltype(C), map(typeof, ys)...) <: eltype(C)

"""
    pop!!(sequence) -> (sequence′, value)
    pop!!(assoc, key) -> (assoc′, value)
    pop!!(assoc, key, default) -> (assoc′, value)

# Examples
```jldoctest
julia> using BangBang

julia> pop!!([0, 1])
([0], 1)

julia> pop!!((0, 1))
((0,), 1)

julia> pop!!(Dict(:a => 1), :a)
(Dict{Symbol, Int64}(), 1)

julia> pop!!((a=1,), :a)
(NamedTuple(), 1)

julia> using StaticArrays: SVector

julia> @assert pop!!(SVector(1, 2)) === (SVector(1), 2)
```
"""
pop!!
pop!!(xs, args...) = may(_pop!, xs, args...)
_pop!(xs, args...) = xs, pop!(xs, args...)

pure(::typeof(_pop!)) = NoBang.pop
possible(::typeof(_pop!), ::C, ::Vararg) where C = implements(push!, C)

"""
    deleteat!!(assoc, i) -> assoc′

# Examples
```jldoctest
julia> using BangBang

julia> deleteat!!((1, 2, 3), 2)
(1, 3)

julia> deleteat!!([1, 2, 3], 2)
2-element Vector{Int64}:
 1
 3

julia> using StaticArrays: SVector

julia> @assert deleteat!!(SVector(1, 2, 3), 2) === SVector(1, 3)
```
"""
deleteat!!
deleteat!!(xs, key) = may(deleteat!, xs, key)

pure(::typeof(deleteat!)) = NoBang.deleteat
_asbb(::typeof(deleteat!)) = deleteat!!
possible(::typeof(deleteat!), ::C, ::Any) where C = implements(push!, C)

"""
    delete!!(assoc, key) -> assoc′

# Examples
```jldoctest
julia> using BangBang

julia> delete!!((a=1, b=2), :a)
(b = 2,)

julia> delete!!(Dict(:a=>1, :b=>2), :a)
Dict{Symbol, Int64} with 1 entry:
  :b => 2
```
"""
delete!!
delete!!(xs, key) = may(delete!, xs, key)

pure(::typeof(delete!)) = NoBang.delete
_asbb(::typeof(delete!)) = delete!!
possible(::typeof(delete!), ::C, ::Any) where C = implements(push!, C)

"""
    popfirst!!(sequence) -> (sequence′, value)

# Examples
```jldoctest
julia> using BangBang

julia> popfirst!!([0, 1])
([1], 0)

julia> popfirst!!((0, 1))
((1,), 0)

julia> popfirst!!((a=0, b=1))
((b = 1,), 0)

julia> using StaticArrays: SVector

julia> @assert popfirst!!(SVector(1, 2)) === (SVector(2), 1)
```
"""
popfirst!!
popfirst!!(xs) = may(_popfirst!, xs)
_popfirst!(xs) = xs, popfirst!(xs)

pure(::typeof(_popfirst!)) = NoBang.popfirst
possible(::typeof(_popfirst!), ::C,) where C = implements(push!, C)

"""
    empty!!(collection) -> collection′

# Examples
```jldoctest
julia> using BangBang

julia> empty!!((1, 2, 3))
()

julia> empty!!((a=1, b=2, c=3))
NamedTuple()

julia> xs = [1, 2, 3];

julia> empty!!(xs)
Int64[]

julia> xs
Int64[]

julia> using StaticArrays: SVector

julia> @assert empty!!(SVector(1, 2)) == SVector{0, Int}()
```
"""
empty!!
empty!!(xs) = may(empty!, xs)

pure(::typeof(empty!)) = NoBang._empty
_asbb(::typeof(empty!)) = empty!!
possible(::typeof(empty!), ::C) where C = implements(push!, C)

"""
    mergewith!!(combine, dictlike, others...) -> dictlike′
    mergewith!!(combine)

Like `merge!!(combine, dictlike, others...)` but `combine` does not have
to be a `Function`.

This function "owns" `dictlike` but not `others`.  See
[`merge!!`](@ref) for more details.

The curried form `mergewith!!(combine)` returns the function
`(args...) -> mergewith!!(combine, args...)`.
"""
mergewith!!

mergewith!!(combine, dict, other) =
    foldl(pairs(other); init=dict) do dict, (k, v2)
        newdict, = Extras.modify!!(dict, k) do ans
            Some(ans === nothing ? v2 : combine(something(ans), v2))
        end
        return newdict
    end

mergewith!!(combine, dict, others...) = foldl(mergewith!!(combine), others; init = dict)
mergewith!!(combine) = MergeWith!!(combine)

struct MergeWith!!{F} <: Function
    combine::F
end

(f::MergeWith!!)(dict, others...) = mergewith!!(f.combine, dict, others...)

"""
    merge!!(dictlike, others...) -> dictlike′
    merge!!(combine, dictlike, others...) -> dictlike′

Merge key-value pairs from `others` to `dictlike`.  Mutate `dictlike`
if possible.

This function "owns" `dictlike` but not `others`; i.e., returned value
`dictlike′` does not alias any of `others`.  For example,
`merge!!(Empty(Dict), other)` shallow-copies `other` instead of
returning `other` as-is.

Method `merge!!(combine::Union{Function,Type}, args...)` as an alias
of `mergewith!!(combine, args...)` is still available for backward
compatibility.

See also [`mergewith!!`](@ref).

# Examples
```jldoctest
julia> using BangBang

julia> merge!!(Dict(:a => 1), Dict(:b => 0.5))
Dict{Symbol, Float64} with 2 entries:
  :a => 1.0
  :b => 0.5

julia> merge!!((a = 1,), Dict(:b => 0.5))
(a = 1, b = 0.5)

julia> merge!!(+, Dict(:a => 1), Dict(:a => 0.5))
Dict{Symbol, Float64} with 1 entry:
  :a => 1.5
```

`merge!!` does not own the second argument:

```jldoctest; setup = :(using BangBang)
julia> xs = Dict(:a => 1, :b => 2, :c => 3);

julia> ys = merge!!(Empty(Dict), xs)
Dict{Symbol, Int64} with 3 entries:
  :a => 1
  :b => 2
  :c => 3

julia> ys === xs
false
```
"""
merge!!
merge!!(dict, others...) = merge!!(right, dict, others...)
merge!!(combine::Base.Callable, dict, others...) =
    mergewith!!(combine, dict, others...)

right(_, x) = x

#=
"""
    splice!!(sequence, i, [replacement]) -> (sequence′, item)
    splice!!(sequence, range, [replacement]) -> (sequence′, items)
"""
=#

"""
    splice!!(sequence, i, [replacement]) -> (sequence′, item)

# Examples
```jldoctest
julia> using BangBang

julia> splice!!([1, 2, 3], 2)
([1, 3], 2)

julia> splice!!((1, 2, 3), 2)
((1, 3), 2)

julia> using StaticArrays: SVector

julia> @assert splice!!(SVector(1, 2, 3), 2) === (SVector(1, 3), 2)
```
"""
splice!!
splice!!(xs, args...) = may(_splice!, xs, args...)
_splice!(xs, args...) = xs, splice!(xs, args...)

pure(::typeof(_splice!)) = NoBang.splice
possible(::typeof(_splice!), ::C, ::Any) where C = implements(push!, C)
possible(::typeof(_splice!), xs::C, i::Integer, ::S) where {C, S} =
    possible(_splice!, xs, i) && promote_type(eltype(C), S) <: eltype(C)
possible(::typeof(_splice!), xs::C, i::Any, ::S) where {C, S} =
    possible(_splice!, xs, i) && promote_type(eltype(C), eltype(S)) <: eltype(C)

"""
    setindex!!(collection, value, indices...) -> collection′

# Examples
```jldoctest
julia> using BangBang

julia> setindex!!((1, 2), 10.0, 1)
(10.0, 2)

julia> setindex!!([1, 2], 10.0, 1)
2-element Vector{Float64}:
 10.0
  2.0

julia> using StaticArrays: SVector

julia> @assert setindex!!(SVector(1, 2), 10.0, 1) == SVector(10.0, 2.0)
```
"""
setindex!!
Base.@propagate_inbounds setindex!!(xs, v, I...) = may(_setindex!, xs, v, I...)

Base.@propagate_inbounds _setindex!(xs, v, I...) = (setindex!(xs, v, I...); xs)

pure(::typeof(_setindex!)) = NoBang._setindex
possible(::typeof(_setindex!), ::Union{Tuple,NamedTuple,Empty}, ::Vararg) = false
possible(::typeof(_setindex!), ::C, ::V, ::K) where {C <: AbstractDict, V, K} =
    implements(setindex!, C) &&
    promote_type(keytype(C), K) <: keytype(C) &&
    promote_type(valtype(C), V) <: valtype(C)

# Default implementation for `_setindex!` with `AbstractArray`.
# But this will return `false` even in cases such as
#
#     setindex!!([1, 2, 3], [4, 5, 6], :)
#
# because `promote_type(eltype(C), T) <: eltype(C)` is `false`.
possible(::typeof(_setindex!), ::C, ::T, ::Vararg) where {C <: AbstractArray, T} =
    implements(setindex!, C) && promote_type(eltype(C), T) <: eltype(C)

# To address this, we specialize on the case where `T<:AbstractArray`.
# In addition, we need to support a wide range of indexing behaviors:
#
# We also need to ensure that the dimensionality of the index is
# valid, i.e. that we're not returning `true` in cases such as
#
#     setindex!!([1, 2, 3], [4, 5], 1)
#
# which should return `false`.
_index_dimension(::Any) = 0
_index_dimension(::Colon) = 1
_index_dimension(::AbstractVector) = 1
_index_dimension(indices::Tuple) = sum(map(_index_dimension, indices))

function possible(
    ::typeof(_setindex!),
    ::C,
    ::T,
    indices::Vararg
) where {T<:AbstractArray,C<:AbstractArray}
    # Extract the dimensionality of `T` here instead of in the signature
    # to make it easier to perform further specializations on `T`.
    M = ndims(T)
    return implements(setindex!, C) &&
        promote_type(eltype(C), eltype(T)) <: eltype(C) &&
        # This will still return `false` for scenarios such as
        #
        #     setindex!!([1, 2, 3], [4, 5, 6], :, 1)
        #
        # which are in fact valid. However, this cases are rare.
        (_index_dimension(indices) == M || _index_dimension(indices) == 1)
end

# Specialization: `setindex!(::C,::T)` where `C<:AbstractArray{T}`
function possible(
    ::typeof(_setindex!),
    ::C,
    ::T,
    indices::Vararg
) where {T,C<:AbstractArray{T}}
    return implements(setindex!, C) && _index_dimension(indices) == 0
end
# Specialization: `setindex!(::C,::C)` where `C<:AbstractArray`.
function possible(
    ::typeof(_setindex!),
    ::C,
    ::T,
    indices::Vararg
) where {T<:AbstractArray,C<:AbstractArray{T}}
    return implements(setindex!, C) && _index_dimension(indices) == 0
end

"""
    resize!!(vector::AbstractVector, n::Integer) -> vector′
"""
resize!!
resize!!(xs::Union{AbstractVector,Empty{<:AbstractVector}}, n::Integer) =
    implements(resize!, xs) ? resize!(xs, n) : NoBang.resize(xs, n)

pure(::typeof(resize!)) = NoBang.resize
_asbb(::typeof(resize!)) = resize!!

"""
    setproperties!!(value, patch::NamedTuple)
    setproperties!!(value; patch...)

# Examples
```jldoctest
julia> using BangBang

julia> setproperties!!((a=1, b=2); b=3)
(a = 1, b = 3)

julia> struct Immutable
           a
           b
       end

julia> setproperties!!(Immutable(1, 2); b=3)
Immutable(1, 3)

julia> mutable struct Mutable{T, S}
           a::T
           b::S
       end

julia> s = Mutable(1, 2);

julia> setproperties!!(s; b=3)
Mutable{Int64, Int64}(1, 3)

julia> setproperties!!(s, b=4.0)
Mutable{Int64, Float64}(1, 4.0)

julia> s
Mutable{Int64, Int64}(1, 3)
```
"""
@inline setproperties!!(value, patch) = may(setproperties!, value, patch)
@inline setproperties!!(value; patch...) = setproperties!!(value, (; patch...))

@inline function setproperties!(value, patch)
    for (k, v) in pairs(patch)
        setproperty!(value, k, v)
    end
    return value
end

@inline function setproperties!(value, patch::NamedTuple)
    ntuple(length(patch)) do i
        setproperty!(value, keys(patch)[i], patch[i])
    end
    return value
end

pure(::typeof(setproperties!)) = NoBang.setproperties
possible(::typeof(setproperties!), obj, patch) =
    implements(setproperty!, obj) && _is_compatible_field_types(obj, patch)

_is_compatible_field_types(::T, patch) where T =
    all(n -> fieldtype(typeof(patch), n) <: fieldtype(T, n), keys(patch))

@generated function _is_compatible_field_types(obj, patch::NamedTuple{pnames}) where pnames
    all(n -> fieldtype(patch, n) <: fieldtype(obj, n), pnames)
end

"""
    setproperty!!(value, name::Symbol, x)

An alias of `setproperties!!(value, (name=x,))`.
"""
setproperty!!
@inline setproperty!!(value, name::Symbol, x) =
    setproperties!!(value, NamedTuple{(name,)}((x,)))

"""
    materialize!!(dest, x)

```jldoctest
julia> using BangBang

julia> using Base.Broadcast: instantiate, broadcasted

julia> bc = instantiate(broadcasted(+, [1.0, 1.5, 2.0], 1));

julia> xs = zeros(Float64, 3);

julia> ys = materialize!!(xs, bc)
3-element Vector{Float64}:
 2.0
 2.5
 3.0

julia> xs === ys  # mutated
true

julia> xs = Vector{Union{}}(undef, 3);

julia> ys = materialize!!(xs, bc)
3-element Vector{Float64}:
 2.0
 2.5
 3.0

julia> xs === ys
false
```
"""
@inline materialize!!(dest, x) = may(_materialize!!, dest, x)
# TODO: maybe instantiate `x` and be aware of `x`'s style
# TODO: move `materialize!!` to broadcast.jl

@inline _materialize!!(dest, bc::Broadcasted{Style}) where {Style} =
    _copyto!!(dest, instantiate(Broadcasted{Style}(bc.f, bc.args, axes(dest))))

@inline _materialize!!(dest, x) = _materialize!!(dest, instantiate(broadcasted(identity, x)))

pure(::typeof(_materialize!!)) = NoBang.materialize
possible(::typeof(_materialize!!), ::Any, ::Any) = false
possible(::typeof(_materialize!!), x::AbstractArray, ::Any) = implements(push!, x)

@noinline throwdm(axdest, axsrc) =
    throw(DimensionMismatch("destination axes $axdest are not compatible with source axes $axsrc"))

# Based on default `copy(bc)` implementation
@inline function _copyto!!(dest, bc::Broadcasted)
    axes(dest) == axes(bc) || throwdm(axes(dest), axes(bc))

    ElType = combine_eltypes(bc.f, bc.args)
    # Use `copyto!` if we can trust the inference result:
    if ElType <: eltype(dest)
        return copyto!(dest, bc)
    elseif Base.isconcretetype(ElType)
        return copyto!(similar(bc, promote_typejoin(eltype(dest), ElType)), bc)
    end

    bc′ = preprocess(nothing, bc)
    iter = eachindex(bc′)
    y = iterate(iter)
    y === nothing && return dest

    # Try to store the first value
    I, state = y
    @inbounds val = bc′[I]
    if typeof(val) <: eltype(dest)
        dest′ = dest
    else
        dest′ = similar(bc′, typeof(val))
    end
    @inbounds dest′[I] = val

    # Handle the rest
    return copyto_nonleaf!(dest′, bc′, iter, state, 1)
end

"""
    unique!!(set) -> set
    unique!!(sequence) -> sequence′
"""
unique!!
unique!!(itr) = unique(itr)
unique!!(set::AbstractSet) = set
unique!!(xs::AbstractVector) = may(unique!, xs)

pure(::typeof(unique!)) = unique
_asbb(::typeof(unique!)) = unique!!
possible(::typeof(unique!), ::C) where {C} = implements(push!, C)

"""
    union!!(setlike, others...) -> setlike′

Return the union of all sets in the arguments.  Mutate `setlike` if
possible.

This function "owns" `setlike` but not `others`; i.e., returned value
`setlike′` does not alias any of `others`.  For example,
`union!!(Empty(Set), other)` shallow-copies `other` instead of
returning `other` as-is.

# Examples
```jldoctest
julia> using BangBang

julia> xs = Set([1]);

julia> ys = union!!(xs, Set([2]));  # mutates `xs` as it's possible

julia> ys == Set([1, 2])
true

julia> ys === xs  # `xs` is returned
true

julia> zs = union!!(xs, Set([0.5]));  # incompatible element type

julia> zs == Set([0.5, 1, 2])
true

julia> zs === xs  # a new set is returned
false
```

`union!!` does not own the second argument:

```jldoctest; setup = :(using BangBang)
julia> xs = Set([1]);

julia> ys = union!!(Empty(Set), xs)
Set{Int64} with 1 element:
  1

julia> ys === xs
false
```
"""
union!!
union!!(args...) = may(union!, args...)

pure(::typeof(union!)) = NoBang._union
_asbb(::typeof(union!)) = union!!
possible(::typeof(union!), ::C, ts...) where C<:Union{AbstractSet,AbstractVector} =
    implements(push!, C) &&
    all(t -> IteratorEltype(t) isa HasEltype, ts) &&
    promote_type(eltype(C), map(eltype, ts)...) <: eltype(C)
possible(::typeof(union!), ::Empty, ts...) = false
# TODO: simplify `possible` after deciding what to do with dictionaries

"""
    intersect!!(setlike, others...) -> setlike′

Return the set of elements in `setlike` and in all the collections
`others`. Mutate `setlike` if possible.

This function "owns" `setlike` but not `others`; i.e., returned value
`setlike′` does not alias any of `others`.  For example,
`other = Set([1]); intersect!!(Set([1, 2]), other)` does not return `other` as-is.

# Examples
```jldoctest
julia> using BangBang

julia> xs = Set([1, 2]);

julia> ys = intersect!!(xs, [1]);  # mutates `xs` as it's possible

julia> ys == Set([1])
true

julia> ys === xs  # `xs` is returned
true
```
"""
intersect!!
intersect!!(args...) = may(intersect!, args...)

pure(::typeof(intersect!)) = NoBang._intersect
_asbb(::typeof(intersect!)) = intersect!!
possible(::typeof(intersect!), ::C, ::Any...) where {C<:Union{AbstractSet,AbstractVector}} =
    implements(push!, C)
possible(::typeof(intersect!), ::Empty, ts...) = false
# TODO: simplify `possible` after deciding what to do with dictionaries

"""
    setdiff!!(setlike, others...) -> setlike′

Return the set of elements in `setlike` but not in any of the collections
`others`. Mutate `setlike` if possible.

This function "owns" `setlike` but not `others`; i.e., returned value
`setlike′` does not alias any of `others`.  For example,
`other = Set([]); setdiff!!(Empty(Set), other)` does not return `other` as-is.

# Examples
```jldoctest
julia> using BangBang

julia> xs = Set([1]);

julia> ys = setdiff!!(xs, [1]);  # mutates `xs` as it's possible

julia> ys == Set([])
true

julia> ys === xs  # `xs` is returned
true
```
"""
setdiff!!
setdiff!!(args...) = may(setdiff!, args...)

pure(::typeof(setdiff!)) = NoBang._setdiff
_asbb(::typeof(setdiff!)) = setdiff!!
possible(::typeof(setdiff!), ::C, ::Any...) where {C<:Union{AbstractSet,AbstractVector}} =
    implements(push!, C)
possible(::typeof(setdiff!), ::Empty, ts...) = false
# TODO: simplify `possible` after deciding what to do with dictionaries

"""
    symdiff!!(setlike, others...) -> setlike′

Return the set of elements that occur an odd number of times in
`setlike` and the `others` collections. Mutate `setlike` if possible.

This function "owns" `setlike` but not `others`; i.e., returned value
`setlike′` does not alias any of `others`.  For example,
`symdiff!!(Empty(Set), other)` shallow-copies `other` instead of
returning `other` as-is.

# Examples
```jldoctest
julia> using BangBang

julia> xs = Set([1, 2]);

julia> ys = symdiff!!(xs, [2, 3]);  # mutates `xs` as it's possible

julia> ys == Set([1, 3])
true

julia> ys === xs  # `xs` is returned
true
```
"""
symdiff!!
symdiff!!(args...) = may(symdiff!, args...)

pure(::typeof(symdiff!)) = NoBang._symdiff
_asbb(::typeof(symdiff!)) = symdiff!!
possible(::typeof(symdiff!), ::C, ts...) where C<:Union{AbstractSet,AbstractVector} =
    implements(push!, C) &&
    all(t -> IteratorEltype(t) isa HasEltype, ts) &&
    promote_type(eltype(C), map(eltype, ts)...) <: eltype(C)
possible(::typeof(symdiff!), ::Empty, ts...) = false
# TODO: simplify `possible` after deciding what to do with dictionaries

module TestSetdiff

include("preamble.jl")
# using MicroCollections: SingletonSet

@testset begin
    @test_returns_first setdiff!!([0]) == [0]
    @test_returns_first setdiff!!(Set([0])) == Set([0])
    @test_returns_first setdiff!!([0], [0]) == []
    @test_returns_first setdiff!!([0], (0,)) == []
    @test_returns_first setdiff!!([0, 1, 2], (0,), [1]) == [2]
    @test_returns_first setdiff!!(Set([0]), [0]) == Set()
    @test_returns_first setdiff!!(Set([0]), (0,)) == Set()
    @test_returns_first setdiff!!(Set([0, 1, 2]), Set([0]), [1]) == Set([2])
    @test setdiff!!(Empty(Set)) === Empty(Set)
    @test setdiff!!(Empty(Vector), Empty(Set)) === Empty(Vector)
    @test setdiff!!(Empty(Set{Int}), []) === Empty(Set{Int})
    #=
    @test setdiff!!(SingletonSet((0,)), [0]) ==ₜ Set{Int}()
    @test setdiff!!(SingletonSet((0,)), [1]) ==ₜ Set([0])
    =#
end

end  # module

module TestSetProperty

include("preamble.jl")

struct ImmutableStruct
    a
    b
end

mutable struct MutableStruct
    a
    b
end

@testset begin
    @test setproperty!!((a=1, b=nothing), :b, 2) === (a=1, b=2)
    @test setproperty!!(ImmutableStruct(1, nothing), :b, 2) ==
        ImmutableStruct(1, 2)
    ms = MutableStruct(1, nothing)
    @test setproperty!!(ms, :b, 2) === ms
    @test ms.b == 2
end

@testset "inference" begin
    nt = (a = 1, b = 2)
    f!!(nt) = setproperty!!(nt, :a, 3)
    @test @inferred(f!!(nt)) == (a = 3, b = 2)
end

end  # module

module TestBangBang
using Test

@testset "$file" for file in sort([file for file in readdir(@__DIR__) if match(
    r"^test_.*\.jl$",
    file,
) !== nothing])

    if file == "test_doctest.jl"
        if lowercase(get(ENV, "JULIA_PKGEVAL", "false")) == "true"
            @info "Skipping doctests on PkgEval."
            continue
        elseif Int ≠ Int64
            @info "Skipping doctests on non x64 arch"
            continue
        elseif !(v"1.6" <= VERSION < v"1.7-")
            @info "Skipping doctests on Julia $VERSION."
            continue
        end
    end

    if file == "test_zygote.jl"
        if lowercase(get(ENV, "JULIA_PKGEVAL", "false")) == "true"
            @info "Skipping tests with Zygote on PkgEval."
            continue
        elseif VERSION < v"1.2-"
            @info "Skip $file for Julia $VERSION to avoid segfault"
            # For example:
            # https://travis-ci.com/JuliaFolds/BangBang.jl/builds/134791701
            # https://travis-ci.com/JuliaFolds/BangBang.jl/builds/134795161
            continue
        elseif VERSION >= v"1.10-"
            @info "Skip $file for Julia $VERSION"
            # For example:
            continue
        end
    end

    include(file)
end

end  # module

module TestMerge

include("preamble.jl")
using BangBang.NoBang: SingletonDict
using InitialValues: InitialValue, asmonoid

function signature(args)
    #! format: off
    strs = (
        if a isa Function
            string(a)
        elseif a isa NamedTuple
            "::NamedTuple"
        else
            "::$(typeof(a))"
        end for a in args
    )
    #! format: on
    return join(strs, ", ")
end

@testset "widen" begin
    @testset "merge!!($(signature(args)))" for (args, desired) in Any[
        ((Dict(:a => 1), Dict(:b => 0.5)), Dict(:a => 1.0, :b => 0.5)),
        ((Dict(:a => 1), Dict("b" => 2)), Dict(:a => 1, "b" => 2)),
        ((Dict(:a => 1), Dict("b" => 0.5)), Dict(:a => 1.0, "b" => 0.5)),
        (((a = 1,), (b = 2,)), (a = 1, b = 2)),
        (((a = 1,), Dict(:b => 2)), (a = 1, b = 2)),
        (((a = 1,), Dict(:b => 2), (b = 3,)), (a = 1, b = 3)),
        ((Empty(Dict), Dict(:a => 1)), Dict(:a => 1)),
        ((Empty(Dict), SingletonDict(:a => 1)), Dict(:a => 1)),
        ((SingletonDict(:a => 1), Dict(:b => 2)), Dict(:a => 1, :b => 2)),
        ((SingletonDict(:a => 1), Dict(:a => 2)), Dict(:a => 2)),
    ]
        d = deepcopy(args[1])
        @test merge!!(args...) ==ₜ desired
        @test args[1] == d
    end
    @testset "merge!!($(signature(args)))" for (args, desired) in Any[
        ((+, Dict(:a => 1), Dict(:a => 0.5)), Dict(:a => 1.5)),
        ((+, (a = 1,), Dict(:a => 0.5)), (a = 1.5,)),
    ]
        d = deepcopy(args[2])
        @test merge!!(args...) ==ₜ desired
        @test args[2] == d
    end
end

@testset "mutate" begin
    @testset "merge!!($(signature(args)))" for (args, desired) in Any[
        ((Dict(:a => 1), Dict(:b => 2)), Dict(:a => 1, :b => 2)),
        ((Dict(:a => 1), (b = 2,)), Dict(:a => 1, :b => 2)),
    ]
        @test merge!!(args...) === args[1] == desired
    end
    @testset "merge!!($(signature(args)))" for (args, desired) in Any[
        ((+, Dict(:a => 1), Dict(:a => 2)), Dict(:a => 3)),
        ((+, Dict(:a => 1), (a = 2,)), Dict(:a => 3)),
        ((+, Dict(:a => 1), (a = 2,), Dict(:a => 3)), Dict(:a => 6)),
    ]
        @test merge!!(args...) === args[2] == desired
    end
end

@testset "Init" begin
    for m!! in [merge!!, mergewith!!(+)]
        d = Dict(:a => 1)
        @test m!!(d, InitialValue(m!!)) === d
        @test m!!(InitialValue(m!!), d) !== d
        @test m!!(InitialValue(m!!), d) ==ₜ d
        @test m!!(InitialValue(m!!), (x for x in d if true)) ==ₜ d
        @test m!!(InitialValue(m!!), InitialValue(m!!)) === InitialValue(m!!)
        @test asmonoid(m!!) === m!!
    end
end

end  # module

module TestMacro

include("preamble.jl")

@testset begin
    @test (@! push!(empty!([0, 1]), 2, 3)) == [2, 3]
    @test (@! push!(empty!((0, 1)), 2, 3)) == (2, 3)
end

@testset ".=" begin
    @test !@isdefined y
    @test begin
        x = SVector(1, 2)
        @! y .= x .* 2
    end === SVector(2, 4)

    @test !@isdefined y
    @test begin
        x = SVector(1, 2)
        y = SVector(0, 0)
        @! y .= x .* 2
    end === SVector(2, 4)

    let x = [1, 2]
        y = [0, 0]
        @test (@! y .= x .* 2)::Vector{Int} == [2, 4]
    end

    let x = [1, 2]
        y = [0, 0]
        @test (@! y .= x)::Vector{Int} == [1, 2]
    end

    let x = [1, 2]
        y = SVector(0, 0)
        @test (@! y .= x .* 2)::SizedVector{2, Int} == [2, 4]
    end

    let y = [0, 0]
        @test (@! y .= 1)::Vector{Int} == [1, 1]
    end

    let y = SVector(0, 0)
        @test (@! y .= 1) === SVector(1, 1)
    end

    let x = [1, 2]
        y = SVector(0, 0)
        @test (@! y .+= x)::SizedVector{2, Int} == [1, 2]
    end

    let y = SVector(0, 0)
        @test (@! y .+= 1) === SVector(1, 1)
    end
end

@testset "@." begin
    @test !@isdefined y
    @test begin
        x = SVector(1, 2)
        @! @. y = x * 2
    end === SVector(2, 4)

    @test !@isdefined y
    @test begin
        x = SVector(1, 2)
        y = SVector(0, 0)
        @! @. y = x * 2
    end === SVector(2, 4)

    let x = [1, 2]
        y = [0, 0]
        @test (@! @. y = x * 2)::Vector{Int} == [2, 4]
    end

    let x = [1, 2]
        y = [0, 0]
        @test (@! @. y = x)::Vector{Int} == [1, 2]
    end

    let x = [1, 2]
        y = SVector(0, 0)
        @test (@! @. y = x * 2)::SizedVector{2, Int} == [2, 4]
    end

    let y = [0, 0]
        @test (@! @. y = 1)::Vector{Int} == [1, 1]
    end

    let y = SVector(0, 0)
        @test (@! @. y = 1) === SVector(1, 1)
    end

    let x = [1, 2]
        y = SVector(0, 0)
        @test (@! @. y += x)::SizedVector{2, Int} == [1, 2]
    end

    let y = SVector(0, 0)
        @test (@! @. y += 1) === SVector(1, 1)
    end
end

end  # module

module BenchDataFrames

using BangBang: push!!
using BenchmarkTools: @benchmarkable, BenchmarkGroup
using CategoricalArrays: CategoricalVector
using DataFrames: DataFrame
using DataStructures: LittleDict

function repeat_push(df, row, n = 10)
    row = LittleDict(keys(row), values(row))
    for _ = 1:n
        foreach(empty!, eachcol(df))
        for i = 1:2^10
            push!!(df, row)
        end
    end
end

mkrow(x) = (; tuple.(Symbol.('a':'a'+(8-1)), x)...)

suite = BenchmarkGroup()

suite["Int-Int"] = @benchmarkable repeat_push($(DataFrame([mkrow(0)])), $(mkrow(0)))
suite["Missing-Int"] = @benchmarkable repeat_push(
    $(DataFrame([mkrow(missing)])),
    $(mkrow(0)),
)
suite["String-String"] = @benchmarkable repeat_push(
    $(DataFrame([mkrow("x")])),
    $(mkrow("x")),
)
suite["Missing-String"] = @benchmarkable repeat_push(
    $(DataFrame([mkrow(missing)])),
    $(mkrow("x")),
)
suite["Categorical"] = @benchmarkable repeat_push(
    $(DataFrame(mkrow(Ref(CategoricalVector(["x"]))))),
    $(mkrow("x")),
)

end  # module
BenchDataFrames.suite

module TestAdd

include("preamble.jl")
using Base.Broadcast: broadcasted

@testset begin
    @test add!!(1, 2) === 3
    @test add!!((1,), (2,)) === (3,)
    @test add!!([1], [2]) ==ₜ [3]
    @test add!!(SVector(1), SVector(2)) === SVector(3)
    @test add!!(SVector(1), [2]) == [3]  # ok if `SVector(3)`
    @test add!!([1], SVector(2)) ==ₜ [3]
    @test add!!([1], [0.5]) ==ₜ Real[1.5]
end

@testset "mutation" begin
    x = [1]
    @test add!!(x, [2]) === x ==ₜ [3]
end

@testset "broadcasted" begin
    @test @inferred(add!!(broadcasted(*, [1], [2]), [2])) ==ₜ [4]
    @test @inferred(add!!([1], broadcasted(/, [1], [2]))) ==ₜ Real[1.5]

    x = [1]
    @test @inferred(add!!(x, broadcasted(*, [1], [2]))) === x ==ₜ [3]
end

end  # module

module BangBangStructArraysExt
@static if isdefined(Base, :get_extension)
    using BangBang: BangBang
    using StructArrays: StructArrays
else
    using ..BangBang: BangBang
    using ..StructArrays: StructArrays
end
    if isdefined(StructArrays, :append!!)
        BangBang.append!!(xs::StructArrays.StructVector, ys) =
            StructArrays.append!!(xs, ys)
    else
        BangBang.append!!(xs::StructArrays.StructVector, ys) =
            StructArrays.grow_to_structarray!(xs, ys)
    end

    BangBang.push!!(xs::StructArrays.StructVector, ys...) = BangBang.append!!(xs, ys)
end

module TestStaticArrays

include("preamble.jl")
using BangBang: implements
using InitialValues: InitialValue
using StaticArrays:
    MArray, MMatrix, MVector, SArray, SMatrix, SVector, StaticArrays, StaticVector

@testset "implements(push!, _)" begin
    @test !implements(push!, SVector(0))
    @test !implements(push!, SMatrix{1, 1}(0))
    @test !implements(push!, MVector(0))
    @test !implements(push!, MMatrix{1, 1}(0))
end

@testset "implements(setindex!, _)" begin
    @test !implements(setindex!, SVector(0))
    @test !implements(setindex!, SMatrix{1, 1}(0))
    @test implements(setindex!, MVector(0))
    @test implements(setindex!, MMatrix{1, 1}(0))
end

@testset "push!!" begin
    @test push!!(SVector(1, 2, 3), 4) === SVector(1, 2, 3, 4)
    if versionof(StaticArrays) >= v"0.12"  # not sure when it was fixed
        @test push!!(MVector(1, 2, 3), 4) ==ₜ MVector(1, 2, 3, 4)
    else
        # For StaticArrays 0.8
        @test_broken push!!(MVector(1, 2, 3), 4) ==ₜ MVector(1, 2, 3, 4)
        @test push!!(MVector(1, 2, 3), 4)::StaticVector == [1, 2, 3, 4]
    end
end

@testset "append!! with InitialValue(append!!)" begin
    @test append!!(InitialValue(append!!), SVector(1, 2)) === SVector(1, 2)
    @test append!!(SVector(1, 2), InitialValue(append!!)) === SVector(1, 2)
    @test append!!(InitialValue(append!!), MVector(1, 2)) ==ₜ MVector(1, 2)
    xs = MVector(1, 2)
    @test append!!(xs, InitialValue(append!!)) === xs
end

@testset "setindex!!(SArray, ...)" begin
    @test setindex!!(SVector(1, 2, 3), 200, 2) === SVector(1, 200, 3)
    @test_broken setindex!!(SVector(1, 2, 3), 0.2, 2) === SVector(1.0, 0.2, 3.0)
end

@testset "setindex!!(MArray, ...)" begin
    xs = MVector(1, 2, 3)
    @test setindex!!(xs, 200, 2) === xs ==ₜ MVector(1, 200, 3)
    @test_broken setindex!!(xs, 0.2, 2) === xs ==ₜ MVector(1.0, 0.2, 3.0)
end

@testset "empty!!" begin
    @test empty!!(SVector(1)) === SVector{0,Int}()
    @test isempty(empty!!(MVector(1)))
    if versionof(StaticArrays) >= v"0.12"  # not sure when it was fixed
        @test empty!!(MVector(1)) ==ₜ MVector{0,Int}()
    else
        # For StaticArrays 0.8
        @test_broken empty!!(MVector(1)) ==ₜ MVector{0,Int}()
    end
end

@testset "Empty" begin
    @test push!!(Empty(SVector), 1) === SVector(1)
    @test push!!(Empty(SArray), 1) === SVector(1)
    @test push!!(Empty(MVector), 1) ==ₜ MVector(1)
    @test push!!(Empty(MArray), 1) ==ₜ MVector(1)
end

end  # module

import Pkg
using Test
using Base: ImmutableDict
using BangBang
using BangBang: implements
using StaticArrays: SVector, SizedVector

"""
    ==ₜ(x, y)

Check that _type_ and value of `x` and `y` are equal.
"""
==ₜ(_, _) = false
==ₜ(x::T, y::T) where T = x == y

macro test_error(ex)
    quote
        let err = nothing
            try
                $(esc(ex))
            catch err
            end
            @test err isa Exception
            err
        end
    end
end

macro test_inferred(ex)
    esc(:($Test.@test (($Test.@inferred $ex); true)))
end

"""
    @test_returns_first f(x, ...) ==′ rhs

It is transformed
    @test f((tmp = x; tmp), ...) === tmp ==′ rhs
"""
macro test_returns_first(ex)
    Meta.isexpr(ex, :call, 3) || error("need `lhs cmp rhs`; got:\n$ex")
    c, l, r = ex.args
    (Meta.isexpr(l, :call) && length(l.args) > 1)|| error("lhs should be a call; got:\n$l")
    a = l.args[2]
    @gensym x
    l.args[2] = quote
        $x = $a
        $x
    end
    cmp = Expr(:comparison, l, :(===), x, c, r)
    quote
        $Test.@test $cmp
    end |> esc
end

versionof(pkg::Module) = versionof(Base.PkgId(pkg))
if isdefined(Pkg, :dependencies)
    versionof(pkg::Base.PkgId) = Pkg.dependencies()[pkg.uuid].version
else
    versionof(pkg::Base.PkgId) = Pkg.installed()[pkg.name]
end

"""
    broadcast!!(f, dest, As...) -> dest′

A mutate-or-widen version of `dest .= f.(As...)`.
"""
broadcast!!
@inline broadcast!!(f::F, dest, As...) where {F} =
    materialize!!(dest, instantiate(broadcasted(f, As...)))

"""
    broadcast_inplace!!(f, inputoutput, As...) -> inputoutput′

A mutate-or-widen version of `inputoutput .= f.(inputoutput, As...)`.
"""
Extras.broadcast_inplace!!
@inline Extras.broadcast_inplace!!(f::F, inputoutput, As...) where {F} =
    materialize!!(inputoutput, instantiate(broadcasted(f, inputoutput, As...)))

module TestZygote

if VERSION ≥ v"1.6-"
    try
        using Zygote
    catch
        @info "Failed to import Zygote. Trying again with `@stdlib`..."
        push!(LOAD_PATH, "@stdlib")
    end
end

include("preamble.jl")
using Zygote

include("../examples/zygote.jl")
@test g isa Matrix
@test size(g) == (d, d)

end  # module

module TestPop

include("preamble.jl")

@testset "pop(sequence)" begin
    @test pop!!([0, 1]) == ([0], 1)
    @test pop!!((0, 1)) === ((0,), 1)
    @test pop!!((a=0, b=1)) === ((a=0,), 1)
    @test pop!!(SVector(0, 1)) === (SVector(0), 1)
end

@testset "pop(assoc, key)" begin
    @test pop!!(Dict(:a => 1), :a) == (Dict(), 1)
    @test pop!!((a=1,), :a) == (NamedTuple(), 1)
end

@testset "pop(assoc, key, default)" begin
    @test pop!!(Dict(:a => 1), :a, nothing) == (Dict(), 1)
    @test pop!!(Dict(:a => 1), :b, nothing) == (Dict(:a => 1), nothing)
    @test pop!!((a=1,), :a, nothing) == (NamedTuple(), 1)
    @test pop!!((a=1,), :b, nothing) == ((a=1,), nothing)
end

@testset "mutation" begin
    @testset for args in [
        ([0],),
        (Dict(:a => 1), :a),
        (Dict(:a => 1), :a, nothing),
        (Dict(:a => 1), :b, nothing),
    ]
        @test pop!!(args...)[1] === args[1]
    end
end

end  # module

const ImmutableContainer = Union{
    ImmutableDict,
    NamedTuple,
    Tuple,
}

push(xs, i1, i2, items...) =
    foldl(push, items, init=push(push(xs, i1), i2))

push(xs, x) = vcat(xs, singletonof(xs, x))
push(xs::AbstractSet, x) = union(xs, SingletonVector(x))
push(xs::AbstractDict, x::Pair) = merge(xs, SingletonDict(x[1], x[2]))

push(xs::Tuple, items...) = (xs..., items...)

push(xs::NamedTuple{names}, x::Pair{Symbol}) where {names} =
    NamedTuple{(names..., x.first)}((xs..., x.second))

push(xs::NamedTuple{names}, x::Pair{Val{name}}) where {names, name} =
    NamedTuple{(names..., name)}((xs..., x.second))

push(::NamedTuple, x) =
    error("`push(::NamedTuple, x::$(typeof(x)))` is not supported.\n",
          "Use `push(::NamedTuple, :NAME => x)` or ",
          "`push(::NamedTuple, Val(:NAME) => x)`.")

push(xs::ImmutableDict, x::Pair) = ImmutableDict(xs, x)

append(xs, ys) = _append(xs, ys)
_append(xs, ys::Tuple) = push(xs, ys...)
_append(xs, ys::Pairs{Symbol, <:Any, <:Any, <:NamedTuple}) = push(xs, ys...)

function _append(xs, ys)
    next = iterate(ys)
    next === nothing && return xs
    y, state = next
    return foldl(push!!, Iterators.rest(ys, state), init = push(xs, y))
end

append(xs::AbstractVector, ys::AbstractVector) =
    if constructorof(typeof(xs)) === constructorof(typeof(ys))
        vcat(xs, ys)
    elseif !implements(push!, xs) && implements(push!, ys)
        vcat(xs, ys)
    elseif length(ys) == 0
        xs
    else
        # Not so robust:
        # append!!(push(xs, ys[1]), @view ys[2:end])
        zs = push(xs, ys[1])
        length(ys) == 1 && return zs
        foldl(push!!, (@view ys[2:end]), init = zs)
    end

append(xs::ImmutableContainer, ys) = push(xs, ys...)

append(xs::AbstractString, ys::AbstractString) = string(xs, ys)

function pushfirst(xs::AbstractVector, ys...)
    T = promote_type(eltype(xs), map(typeof, ys)...)
    zs = similar(xs, T, length(xs) + length(ys))
    copyto!(zs, length(ys) + 1, xs, 1, length(xs))
    copyto!(zs, 1, ys, 1, length(ys))
    return zs
end

pushfirst(xs::Tuple, ys...) = (ys..., xs...)

@inline splice(xs, i) = deleteat(xs, i), xs[i]
@inline splice(xs::Tuple, i::Integer) = _splice_del((), i - 1, xs...)
@inline _splice_del(pre, n, x, xs...) =
    if length(pre) < n
        _splice_del((pre..., x), n, xs...)
    else
        (pre..., xs...), x
    end

@inline splice(xs, i, v) = _setindex(xs, v, i), xs[i]
@inline splice(xs::Tuple, i::Integer, v) = _splice_insert((), i - 1, v, xs...)
@inline _splice_insert(pre, n, v, x, xs...) =
    if length(pre) < n
        _splice_insert((pre..., x), n, v, xs...)
    else
        (pre..., v, xs...), x
    end

pop(xs::Tuple) = xs[1:end-1], xs[end]
pop(xs::NamedTuple{names}) where {names} =
    NamedTuple{names[1:end-1]}(Tuple(xs)[1:end-1]), xs[end]

maybepop(xs::NamedTuple, key) = maybepop(xs, Val(key))
maybepop(xs::NamedTuple{names}, ::Val{key}) where {names, key} =
    if haskey(xs, key)
        Some((Base.structdiff(xs, NamedTuple{(key,)}), xs[key]))
    else
        nothing
    end

pop(xs::NamedTuple, key, default) =
    something(maybepop(xs, key), Some((xs, default)))

function pop(xs::NamedTuple, key)
    result = maybepop(xs, key)
    result === nothing && throw(KeyError(key))
    return something(result)
end

popfirst(xs::Tuple) = xs[2:end], xs[1]
popfirst(xs::NamedTuple{names}) where {names} =
    NamedTuple{names[2:end]}(Tuple(xs)[2:end]), xs[1]

function deleteat(xs::Tuple, i)
    h, t, = foldl(ntuple(identity, i - 1); init=((), xs)) do (h, t), _
        ((h..., t[1]), Base.tail(t))
    end
    return (h..., Base.tail(t)...)
end

delete(xs::NamedTuple, key) = something(maybepop(xs, key), (xs,))[1]

_empty(xs) = empty(xs)
if VERSION < v"1.3.0-DEV.533"
    _empty(xs::NamedTuple) = NamedTuple()
end

_setindex(xs, v, I...) = Base.setindex(xs, v, I...)
_setindex(xs::NamedTuple, value, name) = merge(xs, (; name => value))

function _setindex(xs::AbstractArray, v, I...)
    T = promote_type(eltype(xs), typeof(v))
    ys = similar(xs, T)
    if eltype(xs) !== Union{}
        copy!(ys, xs)
    end
    ys[I...] = v
    return ys
end

function _setindex(d0::AbstractDict, v, k)
    K = promote_type(keytype(d0), typeof(k))
    V = promote_type(valtype(d0), typeof(v))
    d = Dict{K, V}()
    copy!(d, d0)
    d[k] = v
    return d
end

resize(xs::AbstractVector, n::Integer) = similar(xs, (n,))

setproperty(value, name, x) = setproperties(value, NamedTuple{(name,)}((x,)))

materialize(dest, x) =
    Broadcast.materialize(Broadcast.instantiate(Broadcast.broadcasted(first ∘ tuple, x, dest)))

@inline _union(args...) = union(args...)

@inline _intersect(args...) = intersect(args...)

@inline _setdiff(args...) = setdiff(args...)

@inline _symdiff(args...) = symdiff(args...)

module BangBang

# Use README as the docstring of the module:
@doc read(joinpath(dirname(@__DIR__), "README.md"), String) BangBang

export @!,
       @set!!,
       Empty,
       add!!,
       append!!,
       broadcast!!,
       collector,
       delete!!,
       deleteat!!,
       empty!!,
       finish!,
       intersect!!,
       lmul!!,
       materialize!!,
       merge!!,
       mergewith!!,
       mul!!,
       pop!!,
       popfirst!!,
       prefermutation,
       push!!,
       pushfirst!!,
       rmul!!,
       setdiff!!,
       setindex!!,
       setproperties!!,
       setproperty!!,
       singletonof,
       splice!!,
       symdiff!!,
       union!!,
       unique!!

using Base.Broadcast:
    Broadcasted,
    broadcasted,
    combine_eltypes,
    copyto_nonleaf!,
    instantiate,
    materialize!,
    preprocess
using Base: HasEltype, IteratorEltype, promote_typejoin
using ConstructionBase: constructorof
using InitialValues
using LinearAlgebra

include("utils.jl")

# Used in NoBang:
function implements end
function push!! end
function unique!! end
function union!! end
function symdiff!! end

include("NoBang/NoBang.jl")
using .NoBang: Empty, SingletonVector, singletonof

include("core.jl")
include("base.jl")
include("linearalgebra.jl")
include("extras.jl")
include("broadcast.jl")
include("collectors.jl")
include("initials.jl")
include("macro.jl")
include("accessors.jl")

using .AccessorsImpl: @set!!, prefermutation

end # module

module TestAqua

using Aqua
using BangBang
using Accessors
using Test

stale_deps = Base.VERSION >= v"1.9"
project_toml_formatting = stale_deps
Aqua.test_all(
    BangBang;
    ambiguities=(;exclude=[Base.get, Base.show],),
    stale_deps = false, #remove when Aqua.jl fixes https://github.com/JuliaTesting/Aqua.jl/issues/107
    project_toml_formatting = false  #remove when Aqua.jl fixes https://github.com/JuliaTesting/Aqua.jl/issues/105
)

# @testset "Compare test/Project.toml and test/environments/main/Project.toml" begin
#     @test Text(read(joinpath(@__DIR__, "Project.toml"), String)) ==
#           Text(read(joinpath(@__DIR__, "environments", "main", "Project.toml"), String))
# end

end  # module

module TestEmpty

include("preamble.jl")

@testset begin
    @test empty!!((1, 2, 3)) === ()
    @test empty!!((a=1, b=2, c=3)) === NamedTuple()
    @test empty!!([1, 2, 3]) == []
end

@testset "mutation" begin
    @testset for xs in [
        [0, 1],
    ]
        @test empty!!(xs) === xs
    end
end

end  # module

module TestStructArrays

using Test
using BangBang
using StructArrays

@testset "push!!" begin
    xs = StructVector{ComplexF64}(([1.0, 2.0], [3.0, 4.0]))
    ys = push!!(xs, 5 + 6im)
    @test ys == [1 + 3im, 2 + 4im, 5 + 6im]
    @test_broken xs === ys
    xs = StructVector{Complex{Int}}(([1, 2], [3, 4]))
    ys = push!!(xs, 5.0 + 6.0im)
    @test ys == [1 + 3im, 2 + 4im, 5 + 6im]
    @test_broken eltype(ys) == ComplexF64
end

@testset "append!!" begin
    xs = StructVector{ComplexF64}(([1.0, 2.0], [3.0, 4.0]))
    ys = append!!(xs, [5 + 6im])
    @test ys == [1 + 3im, 2 + 4im, 5 + 6im]
    @test_broken xs === ys
    xs = StructVector{Complex{Int}}(([1, 2], [3, 4]))
    ys = append!!(xs, 5.0 + 6.0im)
    @test ys == [1 + 3im, 2 + 4im, 5 + 6im]
    @test_broken eltype(ys) == ComplexF64
end

@testset "type inference" begin
    @test (@inferred singletonof(StructVector, (a=1,))) == StructVector((a=[1]))
end

end  # module
